using System;
using System.Drawing;

namespace AQUARIUM
{
	/// <summary>
	/// Summary description for XThinkingAgent
	/// v.1.0 (#6)
	/// </summary>
	public class XThinkingAgent : XAgent
	{
		
		private static Color m_Color=Color.Violet;

		public XThinkingAgent(XAgents a_Uplink):base(a_Uplink)
		{
		}

		public override Color AgColor
		{
			get
			{
				return m_Color;
			}
		}

		public XThinkingAgent(XAgents a_Uplink, 
			int a_x, int a_y, int a_xSpeed, int a_ySpeed) : base(a_Uplink, a_x, a_y, a_xSpeed, a_ySpeed)
		{
			m_Color = Color.Violet;
		}

		public XThinkingAgent(XAgents a_Uplink, int a_x, int a_y, int a_xSpeed, int a_ySpeed, XFactor a_Prefs):base(a_Uplink,a_x,a_y,a_xSpeed,a_ySpeed,a_Prefs)
		{

		}

		//   (      )
		private int[] cour = new int[XFactor.Size];

		/// <summary>
		///   
		/// </summary>
		/// <param name="a_Prefs"></param>
		/// <param name="a_Tensity"></param>
		/// <returns></returns>
		public XFactor MyPrefs(XFactor a_Prefs, XFactor a_Tensity)
		{
			//., .  .
			// 
			double n = 0.01;
			// 
			double m = 0.05;
			// 
			// 
			double m_upper = 0.9;
			double m_lower = 0.1;
			//  
			int m_MemorySize = m_Memory.GetMemSize();

			//  
			XFactor Tens = new XFactor(a_Tensity);
			XFactor this_Prefs = new XFactor(a_Prefs);
			XFactor old_Prefs = new XFactor(m_Memory.ReadPrefs(0));
			XFactor new_Prefs = new XFactor();

			//			for (int i = 0; i < Tens.Size; i++)
			//			{
			//				if (Tens[i] == 0)
			//				{
			//					if (this_Prefs[i] < (1 - n))
			//					{
			//						new_Prefs[i] = this_Prefs[i] + n; 
			//					}
			//				}
			//				else
			//				{
			//					if (old_Prefs[i] < this_Prefs[i])
			//					{
			//						if (this_Prefs[i] < m_upper) new_Prefs[i] = this_Prefs[i] + m; 
			//						else new_Prefs[i] = this_Prefs[i] - m; 
			//					}
			//					else
			//					{
			//						if (old_Prefs[i] > this_Prefs[i])
			//						{
			//							if (this_Prefs[i] > m_lower) new_Prefs[i] = this_Prefs[i] - m; 
			//							else new_Prefs[i] = this_Prefs[i] + m;
			//						}
			//					}
			//				}
			//			}


			for (int i = 0; i < XFactor.Size; i++)
			{
				if (Tens[i] == 0)
				{
					if (this_Prefs[i] < (1 - n))
					{
						new_Prefs[i] = this_Prefs[i] + n; 
					}
				}
				else
				{
					//					if (this_Prefs[i] < m_upper) new_Prefs[i] = this_Prefs[i] + m;
					//					else new_Prefs[i] = m_lower;
					if (cour[i] < 30)
					{
						if (this_Prefs[i] < (1 - m)) new_Prefs[i] = this_Prefs[i] + m;
						cour[i]++;
					}
					else for (int j = 0; j < XFactor.Size; j++ )
						  {
							  new_Prefs[i] = 1 - new_Prefs[i]; 
							  cour[i] = 0;
						  }
				}
			}

			return new_Prefs;
		}
		
		
		public void MoveManner()
		{
			XVector m_ModificationSpeed = new XVector();
			//        Random'
			XVector m = new XVector(-50, -50);
			//    (Random)
			m_ModificationSpeed = XVector.GetRandom(100, 100) + m;
				
			//  
			Speed =  Speed + m_ModificationSpeed;
			//  
			Speed.x = (int)((m_ModSpeed * Speed.x) / XVector.Mod(Speed));
			Speed.y = (int)((m_ModSpeed * Speed.y) / XVector.Mod(Speed));		
		}
		
		
		/// <summary>
		/// 
		/// </summary>
		public override void Move()
		{
			//   -      
			XFactor v = m_Uplink.Uplink.m_Attractors.Potential(this.Location);
			this.m_Prefs = this.MyPrefs(this.m_Prefs, v);
			
			//    
			double intent = v * this.m_Prefs;

			if (XVector.IsEqual(this.Location, this.m_Memory.ReadPlace(1)))
			{
				if (XVector.IsEqual(this.m_Memory.ReadPlace(0), this.m_Memory.ReadPlace(2)))
				{
					MoveManner();
				}
				else
				{
					int m = Speed.y;
					Speed.y = Speed.x;
					Speed.x = (-1) * m;
				}
			}
			else if (intent < this.m_Memory.Read(0))
			{
				Speed = (-1) * Speed;
			}
			//   
			this.m_Memory.Add(intent, Speed, this.Location, this.m_Prefs);
		}
	}
}
