using System;
using System.Collections.Generic;
using System.Text;

using AgentContainer = jade.wrapper.AgentContainer;
using jade.core;

namespace MyAgentApplication
{
    class BootStrap
    {
        static void Main(string[] args)
        {
            try{
                Profile profile = new ProfileImpl();
                Runtime runtime = Runtime.instance();
                AgentContainer mainContainer = runtime.createMainContainer(profile);
                if (mainContainer == null)
                {
                    Console.WriteLine("Error! Could not create main container.");
                    throw new ApplicationException();
                }

                mainContainer.createNewAgent(
                    "Agent3",
                    "MyAgentApplication.Agent2",
                    new object[] { }
                ).start();

            }
            catch (Exception ex)
            {
                Console.WriteLine("Fatal global exception {0}", ex);
            }

        }
    }
}
