using System;

using jade.core;
using jade.lang.acl;
using jade.core.behaviours;

using log4net;

using Mailabs.Reasoning;

namespace Mailabs.Tutorial.MAS
{
    public class MessagePollingBehaviour : CyclicBehaviour
    {
        private static readonly ILog logger = LogManager.GetLogger(typeof(MessagePollingBehaviour));

        public MessagePollingBehaviour(Agent agent) : base(agent) {}

        public override void action()
        {
            ACLMessage message = myAgent.receive();
            if (message != null)
            {
                if (message.getPerformative() == ACLMessage.INFORM)
                {
                    logger.Debug("Got message from " + message.getSender().getLocalName());
                    RequestProcessor.ProcessRequest((CommAgent)myAgent, message.getByteSequenceContent());
                }
                else if (message.getPerformative() == ACLMessage.PROPAGATE)
                {
                    ReasoningEntity profile = RequestProcessor.GetObjectFromBytes(message.getByteSequenceContent());
                    logger.Debug(">>> Got response to the recent request, the profile is " + profile.Root);
                }
            }
            else
            {
                block();
            }
        }
    }
}
