/*

  ORe - OWL ontology relevance library for Microsoft .NET
  (http://ore.mailabs.ru)

  Copyright (c) 2005, 2006 Sergey V. Mikhanov (MAILabs)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  Version: $Id: $
  
*/

using System;
using System.Collections;

namespace Mailabs.Reasoning
{
    [Serializable]
    public class OwlRestrictionCollection : CollectionBase  
    {
        public OwlRestriction this[int index]
        {
            get
            {
                return (OwlRestriction)List[index];
            }
            set
            {
                List[index] = value;
            }
        }

        public int Add(OwlRestriction value)
        {
            return List.Add(value);
        }

        public int IndexOf(OwlRestriction value)
        {
            return List.IndexOf(value);
        }

        public void Insert(int index, OwlRestriction value)
        {
            List.Insert(index, value);
        }

        public void Remove(OwlRestriction value)
        {
            List.Remove(value);
        }

        public bool Contains(OwlRestriction value)
        {
            return List.Contains(value);
        }

        protected override void OnInsert(int index, Object value)
        {
            if (!value.GetType().IsSubclassOf(Type.GetType("Mailabs.Reasoning.OwlRestriction")))
                throw new ArgumentException("Value must be of type OwlRestriction.");
        }

        protected override void OnRemove(int index, Object value)
        {
            if (!value.GetType().IsSubclassOf(Type.GetType("Mailabs.Reasoning.OwlRestriction")))
                throw new ArgumentException("Value must be of type OwlRestriction.");
        }

        protected override void OnSet(int index, Object oldValue, Object newValue)
        {
            if (!newValue.GetType().IsSubclassOf(Type.GetType("Mailabs.Reasoning.OwlRestriction")))
                throw new ArgumentException("Value must be of type OwlRestriction.");
        }

        protected override void OnValidate(Object value)
        {
            if (!value.GetType().IsSubclassOf(Type.GetType("Mailabs.Reasoning.OwlRestriction")))
                throw new ArgumentException("Value must be of type OwlRestriction.");
        }
    }
}
