/*

  ORe - OWL ontology relevance library for Microsoft .NET
  (http://ore.mailabs.ru)

  Copyright (c) 2005, 2006 Sergey V. Mikhanov (MAILabs)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  Version: $Id: $
  
*/

using System;

namespace Mailabs.Reasoning
{
    /// <summary>
    ///      OWL/RDF-,   --  URI     .
    /// </summary>
    internal class RdfConsts
    {
        private RdfConsts() {}

        public const string RDF_TYPE = Namespaces.RDF + "type";
        public const string RDF_LIST = Namespaces.RDF + "List";
        
        public const string OWL_CLASS = Namespaces.OWL + "Class";
        public const string OWL_ONTOLOGY = Namespaces.OWL + "Ontology";
        public const string OWL_OBJECT_PROPERTY = Namespaces.OWL + "ObjectProperty";
        public const string OWL_RESTRICTION = Namespaces.OWL + "Restriction";
        public const string OWL_ON_PROPERTY = Namespaces.OWL + "onProperty";
        public const string OWL_ALL_VALUES_FROM = Namespaces.OWL + "allValuesFrom";
        public const string OWL_SOME_VALUES_FROM = Namespaces.OWL + "someValuesFrom";
        public const string OWL_MIN_CARDINALITY = Namespaces.OWL + "minCardinality";
        public const string OWL_MAX_CARDINALITY = Namespaces.OWL + "maxCardinality";
        public const string OWL_EQUIVALENT_CLASS = Namespaces.OWL + "equivalentClass";
        public const string OWL_COMPLEMENT_CLASS = Namespaces.OWL + "complementOf";
        public const string OWL_THING = Namespaces.OWL + "Thing";

        public const string RDFS_CLASS = Namespaces.RDFS + "Class";
        public const string RDFS_SUBCLASS_OF = Namespaces.RDFS + "subClassOf";
        public const string RDFS_SUBPROPERTY_OF = Namespaces.RDFS + "subPropertyOf";
        public const string RDFS_RANGE = Namespaces.RDFS + "range";
        public const string RDFS_DOMAIN = Namespaces.RDFS + "domain";
    }

    internal class Namespaces 
    {
        private Namespaces() {}

        public const string RDF = "http://www.w3.org/1999/02/22-rdf-syntax-ns#";
        public const string RDFS = "http://www.w3.org/2000/01/rdf-schema#";
        public const string OWL = "http://www.w3.org/2002/07/owl#";
        public const string XMLS = "http://www.w3.org/2001/XMLSchema#";
    }

    internal class Consts 
    {
        private Consts() {}

        public const string BLANK_ID = "blankID";
        public const string XMLNS = "xmlns";
        public static readonly string LOCAL_ONTOLOGIES_CACHE = System.Environment.CurrentDirectory + "\\local_ontologies\\";
    }
}
