/*

  ORe - OWL ontology relevance library for Microsoft .NET
  (http://ore.mailabs.ru)

  Copyright (c) 2005, 2006 Sergey V. Mikhanov (MAILabs)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  Version: $Id: $
  
*/

using System;

namespace Mailabs.Reasoning
{
    /// <summary>
    /// ,   . ,   ,     .
    /// </summary>
    [Serializable]
    public class OwlRole
    {
        public readonly string ID;
        public readonly OwlRoleDictionary Parents;
        public readonly bool IsRemote;
        public readonly string Range;
        public readonly string Domain;

        public OwlRole(string id, string range, string domain)
        {
            ID = id;
            Range = range;
            Domain = domain;
            Parents = new OwlRoleDictionary();
        }

        public OwlRole(string id, bool isRemote) : this(id, RdfConsts.OWL_THING, RdfConsts.OWL_THING) 
        {
            IsRemote = isRemote;
        }

        public string RelativeID
        {
            get
            {
                if (ID.LastIndexOf('#') == -1) {
                    return "";
                } else {
                    return ID.Substring(ID.LastIndexOf('#') + 1, ID.Length - ID.LastIndexOf('#') - 1);
                }
            }
        }
    }
}
