/*

  ORe - OWL ontology relevance library for Microsoft .NET
  (http://ore.mailabs.ru)

  Copyright (c) 2005, 2006 Sergey V. Mikhanov (MAILabs)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  Version: $Id: $
  
*/

using System;

namespace Mailabs.Reasoning
{
    /// <summary>
    /// ,     (  ).
    /// ,    AbstractOwlGraph   ,    
    ///      -- ,     .
    /// </summary>
    [Serializable]
    public class ReasoningEntity : AbstractOwlGraph
    {
        public readonly OwlClass Root;
        public double Weight = 1;

        // This is dummy constructor only for performing serialization
        // operations. It needs to be checked how readonly field is being
        // deserialized in this case.
        public ReasoningEntity()
        {
            Root = null;
        }

        public ReasoningEntity(OwlClass root)
        {
            Root = root;
        }

        public override bool Equals(object o)
        {
            if (!(o is ReasoningEntity))
                return false;

            return ((ReasoningEntity)o).Root.Equals(this.Root);
        }

        public override int GetHashCode()
        {
            return Root.GetHashCode();
        }
    }
}
