/*

  ORe - OWL ontology relevance library for Microsoft .NET
  (http://ore.mailabs.ru)

  Copyright (c) 2005, 2006 Sergey V. Mikhanov (MAILabs)

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.

  This program is distributed in the hope that it will be useful,
  but WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.
  
  Version: $Id: $
  
*/

using System;
using System.Collections;

namespace Mailabs.Reasoning
{
    public class Util
    {
        private Util() {}

        public static void Print(Ontology ontology) 
        {
            if (ontology == null)
                return;

            Console.WriteLine("=== Classes ===");
            for (IDictionaryEnumerator e = ontology.Classes.GetEnumerator(); e.MoveNext(); ) 
            {
                if (((OwlClass)e.Value).Parents.Count == 0) 
                {
                    Console.WriteLine(((OwlClass)e.Value).ID);
                    Util.PrintChildren(ontology.Classes, ((OwlClass)e.Value), 1);
                }
            }

            Console.WriteLine("=== Roles ===");
            for (IDictionaryEnumerator e = ontology.Roles.GetEnumerator(); e.MoveNext(); ) 
            {
                if (((OwlRole)e.Value).Parents.Count == 0) 
                {
                    OwlRole role = ((OwlRole)e.Value);
                    Console.WriteLine(role.ID + ": " + role.Range + " -> " + role.Domain);
                    Util.PrintChildren(ontology.Roles, ((OwlRole)e.Value), 1);
                }
            }
        }

        private static void PrintChildren(OwlClassDictionary all, OwlClass parent, int level)
        {
            for (IDictionaryEnumerator e = all.GetEnumerator(); e.MoveNext(); ) 
            {
                if (((OwlClass)e.Value).Parents.Contains(parent.ID)) 
                {
                    for (int i = 0; i < level; i++) 
                    {
                        Console.Write('\t');
                    }
                    Console.WriteLine(((OwlClass)e.Value).ID);
                    Util.PrintChildren(all, ((OwlClass)e.Value), level + 1);
                }
            }
        }

        private static void PrintChildren(OwlRoleDictionary all, OwlRole parent, int level)
        {
            for (IDictionaryEnumerator e = all.GetEnumerator(); e.MoveNext(); ) 
            {
                if (((OwlRole)e.Value).Parents.Contains(parent.ID)) 
                {
                    for (int i = 0; i < level; i++) 
                    {
                        Console.Write('\t');
                    }
                    OwlRole role = ((OwlRole)e.Value);
                    Console.WriteLine(role.ID + ": " + role.Range + " -> " + role.Domain);
                    Util.PrintChildren(all, ((OwlRole)e.Value), level + 1);
                }
            }
        }
    }
}
