using System;
using System.Drawing;
using System.Collections;

namespace AQUARIUM
{
	/// <summary>
	/// v.1.0 (#5)
	///     -- 
	///   .
	/// </summary>
	public abstract class XAgent
	{
		/// <summary>
		///  
		/// for XML to have possibility to load Agent with saved UIN
		/// </summary>
		public uint m_UIN;

		/// <summary>
		///    
		/// </summary>
		protected XAgents m_Uplink;

		/// <summary>
		///   (  )
		/// </summary>
		public int m_Radius;

		/// <summary>
		///   
		/// </summary>
		public double m_ModSpeed;
         
		/// <summary>
		///  
		/// </summary>
		protected XMemory m_Memory;

		/// <summary>
		///  
		/// </summary>
		private static Color m_Color;

		public virtual Color AgColor
		{
			get
			{
				return m_Color;
			}
			set
			{
				m_Color = value;
			}
		}

		public XAgents Uplink
		{
			get
			{
				return m_Uplink;
			}
		}

		/// <summary>
		///  (read only)
		/// </summary>
		public uint UIN
		{
			get
			{
				return m_UIN;
			}
		}
		
		
		/// <summary>
		///       
		/// </summary>
		private XVector m_Location; 
      
		/// <summary>
		///  (read only)
		/// </summary>
		public XVector Location
		{
			get
			{
				return m_Location;
			}
			set
			{
				m_Location = value;
			}
		}

		/// <summary>
		///  
		/// ( )
		/// </summary>
		private XVector m_OldLocation;

		public XVector OldLocation
		{
			get
			{
				return m_OldLocation;
			}
			set
			{
				m_OldLocation = value;
			}
		}

		/// <summary>
		///  
		/// </summary>
		protected XVector m_Speed;
		
		/// <summary>
		///  (read only)
		/// </summary>
		public XVector Speed
		{
			get
			{
				return m_Speed;
			}
			set
			{
				m_Speed=value;
			}
		
		}

		/// <summary>
		///   ( )
		/// </summary>
		protected XFactor m_Prefs;

		/// <summary>
		///  (read only)
		/// </summary>
		public XFactor Prefs
		{
			get
			{
				return m_Prefs;
			}
		}

		public XAgent (XAgents a_Uplink)
		{
			m_UIN = XGeneratorUIN.Generate();
			m_Uplink = a_Uplink;

			Random rand = new Random((int)m_UIN);

			m_Location = new XVector();
			m_Radius=10; 
			m_Location.x = rand.Next(m_Uplink.Uplink.m_Width - 2*m_Radius) + m_Radius;
			m_Location.y = rand.Next(m_Uplink.Uplink.m_Height - 2*m_Radius) + m_Radius;
			m_Prefs = XFactor.GetRandom();
			m_Speed = new XVector();
			m_Speed.x = rand.Next(60)+40;
			m_Speed.y = rand.Next(60)+40;
			m_ModSpeed=XVector.Mod(m_Speed);
			m_Memory = new XMemory(4);
			m_Color = Color.Navy;
		}

		public XAgent (XAgents a_Uplink, int a_x, int a_y, int a_xSpeed, int a_ySpeed)
		{
			m_UIN = XGeneratorUIN.Generate();
			m_Uplink = a_Uplink;
			m_Location = new XVector(a_x, a_y);
			m_Prefs = XFactor.GetIdentity();
			m_Speed = new XVector();
			m_Memory = new XMemory(4);
			m_Prefs = new XFactor();
			m_Radius=10; 
			if (Math.Abs(a_xSpeed)<100) m_Speed.x = a_xSpeed; else m_Speed.x=100*Math.Sign(a_xSpeed);
			if (Math.Abs(a_ySpeed)<100) m_Speed.y = a_ySpeed; else m_Speed.y=100*Math.Sign(a_ySpeed);
			m_ModSpeed=XVector.Mod(m_Speed);
			m_Color = m_Uplink.Uplink.m_BgColor;
		}   

		public XAgent (XAgents a_Uplink, int a_x, int a_y, int a_xSpeed, int a_ySpeed, XFactor a_Prefs): this(a_Uplink,a_x,a_y,a_xSpeed,a_ySpeed)
		{
			m_Prefs = a_Prefs;			
		}  

		private double GetScreenScale()
		{
			return m_Uplink.Uplink.m_ScreenScale;
		}

		/// <summary>
		///  
		/// </summary>
		/// <param name="a_Target"></param>
		public virtual void Draw(Graphics a_Target)
		{
			int x,y,width,height;
			Pen zPen = new Pen(Uplink.Uplink.m_BgColor,2);

			x=m_Uplink.Uplink.WorldToScrX(m_Location.x - (int) (m_Radius/GetScreenScale()));
			y=m_Uplink.Uplink.WorldToScrY(m_Location.y - (int) (m_Radius/GetScreenScale()));
			width=(int) (2*m_Radius/GetScreenScale());
			height=(int) (2*m_Radius/GetScreenScale());
			zPen = new Pen(AgColor, 0);
			a_Target.DrawEllipse(zPen,x,y,width,height);
			zPen.Dispose();
		}

		public virtual void RIPOldDraw(Graphics a_Target)
		{
			int x,y,width,height;
			x=m_Uplink.Uplink.WorldToScrX(OldLocation.x - (int)(m_Radius/GetScreenScale()));
			y=m_Uplink.Uplink.WorldToScrY(OldLocation.y - (int)(m_Radius/GetScreenScale()));
			width=(int) (2*m_Radius/GetScreenScale());
			height=(int) (2*m_Radius/GetScreenScale());
			Pen zPen = new Pen(Uplink.Uplink.m_BgColor,0);
			a_Target.DrawEllipse(zPen,x,y,width,height);
			zPen.Dispose();
		}

		/// <summary>
		///        .
		/// </summary>
		/// <param name="a_Target"></param>
		public virtual void RIPDraw(Graphics a_Target)
		{
			int x,y,width,height;
			x=m_Uplink.Uplink.WorldToScrX(Location.x - (int)(m_Radius/GetScreenScale()));
			y=m_Uplink.Uplink.WorldToScrY(Location.y - (int)(m_Radius/GetScreenScale()));
			width=(int) (2*m_Radius/GetScreenScale());
			height=(int) (2*m_Radius/GetScreenScale());
			Pen zPen = new Pen(Uplink.Uplink.m_BgColor,0);
			a_Target.DrawEllipse(zPen,x,y,width,height);
			zPen.Dispose();
		}

		/// <summary>
		///  Move 
		/// </summary>
		public abstract void Move(); 

		/// <summary>
		///     
		/// </summary>
		/// <param name="a_Location"></param>
		/// <param name="a_Speed"></param>
		public void GetState(out XVector a_Location,out XVector a_Speed)
		{
			a_Location=Location;
			a_Speed=Speed;
		}

		/// <summary>
		///     
		/// </summary>
		/// <param name="a_Location"></param>
		/// <param name="a_Speed"></param>
		public void SetState(XVector a_Location,XVector a_Speed)
		{
			m_OldLocation=Location;
			m_Location=a_Location;
			m_Speed=a_Speed;
		}

		/// <summary>
		///    ()
		/// </summary>
		/// <returns>String</returns>
		public String LogStr()
		{
			String Str;
			Str = "UIN : " + UIN.ToString() + "  Location : ( " + Location.x.ToString() + " , " + Location.y.ToString() + ")" + "\r\n";
			return Str;
		}


      

	}

}
