using System;
using System.Collections;
using System.Xml;
using System.Text.RegularExpressions;
//using System.Windows.Forms;
using System.Reflection;
using System.Drawing;

namespace AQUARIUM
{
	/// <summary>
	/// v.1.0 (#5)
	///   .    .
	/// </summary>
	public class XAgents
	{
      /// <summary>
      ///  
      /// </summary>
		private ArrayList AgentList;

      /// <summary>
      ///      BT
      /// </summary>
      /// <param name="n"></param>
      /// <returns> </returns>
      public ArrayList GetBTAvailableAgents(XAgent a_Agent)
      {
         ArrayList BTAvailableAgentsList = new ArrayList();
			int radius = m_Uplink.m_BTRadius;
			foreach (XAgent zAgent in AgentList)
			{
				if ( (a_Agent!=zAgent)&&(Math.Abs(zAgent.Location.x-a_Agent.Location.x)<radius)&&(Math.Abs(zAgent.Location.y-a_Agent.Location.y)<radius) )
				{
					if (XVector.Distance(zAgent.Location,a_Agent.Location)<radius)
					{
						BTAvailableAgentsList.Add(zAgent);
					}
				}
			}
			return BTAvailableAgentsList;
      }

		public ArrayList GetOldBTAvailableAgents(XAgent a_Agent)
		{
			ArrayList BTAvailableAgentsList = new ArrayList();
			int radius = m_Uplink.m_BTRadius;
			foreach (XAgent zAgent in AgentList)
			{
				if ( (a_Agent!=zAgent)&&(Math.Abs(zAgent.OldLocation.x-a_Agent.OldLocation.x)<radius)&&(Math.Abs(zAgent.OldLocation.y-a_Agent.OldLocation.y)<radius) )
				{
					if (XVector.Distance(zAgent.OldLocation,a_Agent.OldLocation)<radius)
					{
						BTAvailableAgentsList.Add(zAgent);
					}
				}
			}
			return BTAvailableAgentsList;
		}


      /// <summary>
      ///       
      /// </summary>
      /// <param name="i"></param>
      /// <returns>   i</returns>
      public XAgent GetAgent(int i)
      {
			return (AgentList[i]) as XAgent;
      }

		/// <summary>
		///    
		/// </summary>
		private XEngine m_Uplink;

		public XEngine Uplink
		{
			get
			{
				return m_Uplink;
			}
		}

		/// <summary>
		///     XML-
		/// </summary>
		public void SaveInXML(string FileName)
		{
         XmlTextWriter writer = null;
			try
			{
				writer = new XmlTextWriter(FileName,System.Text.Encoding.Unicode);
				writer.Formatting = Formatting.Indented;

				writer.WriteStartDocument();
				writer.WriteStartElement("Agents");
				XAgent zAgent;
				for (int i=0; i<Count(); i++)
				{
					zAgent = this.GetAgent(i);

					writer.WriteStartElement("Agent");

					writer.WriteElementString("Type",zAgent.GetType().ToString());

					writer.WriteElementString("UIN", (zAgent.UIN.ToString()));
					writer.WriteElementString("Radius", (zAgent.m_Radius.ToString()));
					writer.WriteElementString("ModSpeed",zAgent.m_ModSpeed.ToString());
					
					writer.WriteStartElement("Speed");
					writer.WriteElementString("SpeedX", (zAgent.Speed.x.ToString()));
					writer.WriteElementString("SpeedY", (zAgent.Speed.y.ToString()));
					writer.WriteEndElement();

					writer.WriteStartElement("Location");
					writer.WriteElementString("LocationX", (zAgent.Location.x.ToString()));
					writer.WriteElementString("LocationY", (zAgent.Location.y.ToString()));
					writer.WriteEndElement();

					writer.WriteStartElement("Prefs");
					for (int j=0; j<zAgent.Prefs.m_Factor.Length; j++) writer.WriteElementString("Pref" + j.ToString(), zAgent.Prefs.m_Factor[j].ToString());
					writer.WriteEndElement();

					writer.WriteEndElement();
				}
				writer.WriteEndElement();
			}
			finally
			{
				if (writer!=null) writer.Close();
			}
		}

      /// <summary>
      ///    
      /// </summary>
		public void LoadFromXML(string FileName)
		{
			XmlTextReader reader = null;

			try
			{
				reader = new XmlTextReader(FileName);
				reader.WhitespaceHandling = WhitespaceHandling.None;
				RIPDraw();

				this.AgentList = new ArrayList();
				Regex regex = new Regex("^Pref[0-9]{1,}$");
				Regex NumberReg = new Regex("Pref");
				Type zAgentType;
				
				while (reader.Read())
				{
					if (reader.Name=="Agent")
					{
						reader.Read();
						Object zAgent = new object();
						BindingFlags bf = BindingFlags.DeclaredOnly | BindingFlags.Public | BindingFlags.Instance| BindingFlags.NonPublic;
						Object[] args = new Object[5] ;
						args[0]=this;
						args[1]=0;
						args[2]=0;
						args[3]=0;
						args[4]=0;
						if (reader.Name=="Type")
						{
							reader.Read();
							switch (reader.Value)
							{
								case "AQUARIUM.XOrdinaryAgent":
								{
									zAgentType = System.Type.GetType("AQUARIUM.XOrdinaryAgent");
									break;
								}
								case "AQUARIUM.XThinkingAgent":
								{
									zAgentType = System.Type.GetType("AQUARIUM.XThinkingAgent");
									break;
								}
								default:
								{
									zAgentType = System.Type.GetType("AQUARIUM.XOrdinaryAgent");
									break;
								}
							}
							char[] str = {'.'};
							string Name = zAgentType.ToString().Split(str,10)[1];
							zAgent=zAgentType.InvokeMember(Name,bf|BindingFlags.CreateInstance,null,null,args);
							Add(zAgent as XAgent);
						}
					
						while ((reader.Read())&(reader.Name!="Agent"))
						{
							switch (reader.Name)
							{
								case "UIN" :
									reader.Read();
									(zAgent as XAgent).m_UIN=Convert.ToUInt32(reader.Value);
									reader.Read();
									break;
								case "Radius":
									reader.Read();
									(zAgent as XAgent).m_Radius = Convert.ToInt32((reader.Value));
									reader.Read();
									break;
								case "SpeedX":
									reader.Read();
									(zAgent as XAgent).Speed.x = Convert.ToInt32((reader.Value));
									reader.Read();
									break;
								case "SpeedY":
									reader.Read();
									(zAgent as XAgent).Speed.y = Convert.ToInt32((reader.Value));
									reader.Read();
									break;
								case "LocationX":
									reader.Read();
									(zAgent as XAgent).Location.x = Convert.ToInt32((reader.Value));
									reader.Read();
									break;
								case "LocationY":
									reader.Read();
									(zAgent as XAgent).Location.y = Convert.ToInt32((reader.Value));
									reader.Read();
									break;
								
								case "ModSpeed":
									reader.Read();
									(zAgent as XAgent).m_ModSpeed = Convert.ToDouble((reader.Value));
									reader.Read();
									break;
								default :
									if (regex.IsMatch(reader.Name))
									{
										string[] parts = NumberReg.Split(reader.Name);
										
										reader.Read();
										(zAgent as XAgent).Prefs.m_Factor[Convert.ToInt32(parts[1])] = Convert.ToDouble(reader.Value);
										reader.Read();
									}
									break;
							}
						}
					}			
				}
			}
			catch(Exception e)
			{
			
			}
			finally
			{
				if (reader!=null) reader.Close();
			}
		}

      /// <summary>
      ///  
      /// </summary>
      /// <param name="a_Uplink"></param>
		public XAgents(XEngine a_Uplink)
		{
			AgentList=new ArrayList();
			m_Uplink = a_Uplink;
		}

      /// <summary>
      ///   
      /// </summary>
      /// <param name="agent"></param>
		public void Add(XAgent agent)
      {
         AgentList.Add(agent);
      }

      /// <summary>
      ///   
      /// </summary>
      /// <param name="a_v"></param>
      /// <returns>   </returns>
      public int SearchByLocation(XVector a_v) //search by coordinates
      {
         XAgent zAgent;
         int i=0;
         while (i<AgentList.Count)
         {
            zAgent=(AgentList[i])as XAgent;
            double r=XVector.Distance(zAgent.Location,a_v);
            if (r<=(zAgent.m_Radius/m_Uplink.m_ScreenScale))
            {
               return (i);
            } else i++;
         }
         return (-1);
      }

      /// <summary>
      ///  
      /// </summary>
      /// <param name="agent">UIN </param>
		public void Remove(int a_i)
      {
	      // TODO: !!
			AgentList.RemoveAt(a_i);
      }

      /// <summary>
      ///   
      /// </summary>
      /// <returns></returns>
      public int Count()
      { 
         return (AgentList.Count);
      }

      /// <summary>
      ///   
      /// </summary>
      public void Draw()
      {
         foreach (XAgent zAgent in AgentList)
         {
				ArrayList Neighbours = GetOldBTAvailableAgents(zAgent);
				Pen pen = new Pen(Uplink.m_BgColor);
				foreach (XAgent zNeighbourAgent in Neighbours)
				{
					m_Uplink.m_Canvas.DrawLine(pen,m_Uplink.WorldToScrX(zAgent.OldLocation.x),m_Uplink.WorldToScrY(zAgent.OldLocation.y),m_Uplink.WorldToScrX(zNeighbourAgent.OldLocation.x),m_Uplink.WorldToScrY(zNeighbourAgent.OldLocation.y));
				}

				if (m_Uplink.WasVisibleAgent(zAgent))
				{
					zAgent.RIPOldDraw(m_Uplink.m_Canvas);
				}
				if (m_Uplink.IsVisibleAgent(zAgent)) 
				{				
					zAgent.Draw(m_Uplink.m_Canvas);
				}
            
				pen = new Pen(Color.Red);
				Neighbours = GetBTAvailableAgents(zAgent);
				foreach (XAgent zNeighbourAgent in Neighbours)
				{
					m_Uplink.m_Canvas.DrawLine(pen,m_Uplink.WorldToScrX(zAgent.Location.x),m_Uplink.WorldToScrY(zAgent.Location.y),m_Uplink.WorldToScrX(zNeighbourAgent.Location.x),m_Uplink.WorldToScrY(zNeighbourAgent.Location.y));
				}
				pen.Dispose();
         }
      }

		/// <summary>
		///   ,    
		/// </summary>
		public void RIPDraw()
		{
			Pen pen = new Pen(m_Uplink.m_BgColor);
			foreach (XAgent zAgent in AgentList)
			{
				if (m_Uplink.IsVisibleAgent(zAgent)) 
				{
					zAgent.RIPDraw(m_Uplink.m_Canvas);
				}

				ArrayList Neighbours = GetOldBTAvailableAgents(zAgent);
				foreach (XAgent zNeighbourAgent in Neighbours)
				{
					m_Uplink.m_Canvas.DrawLine(pen,m_Uplink.WorldToScrX(zAgent.Location.x),m_Uplink.WorldToScrY(zAgent.Location.y),m_Uplink.WorldToScrX(zNeighbourAgent.Location.x),m_Uplink.WorldToScrY(zNeighbourAgent.Location.y));
				}
			}
			pen.Dispose();
		}

      /// <summary>
      ///   
      /// </summary>
      public void Move()
      {
         foreach (XAgent agent in AgentList) 
         {
            agent.Move();
         }
      }

		/// <summary>
		///    
		/// </summary>
		/// <returns>String</returns>
		public String LogStr()
		{
			String Str;
			Str = "  : \r\n";
			foreach (XAgent zAgent in AgentList)
			{
				Str = Str + zAgent.LogStr();
			}
			return Str;
		}

	}
}
