using System;
using System.Drawing;
using System.Drawing.Drawing2D;

namespace AQUARIUM
{
	/// <summary>
	/// v.1.0 (#5)
	///  (  )
	/// </summary>
	public class XAttractor
	{
      public uint m_UIN;

		/// <summary>
		///  
		/// </summary>
		private XVector m_Location;

      public XVector Location
      {
         get
         {
            return m_Location;
         }
      }

      private XVector m_OldLocation;

      public XVector OldLocation
      {
         get
         {
            return m_OldLocation;
         }
      }

      public void SetState(XVector a_v)
      {
         m_Location=a_v;
      }

		/// <summary>
		/// -  
		/// </summary>
	   public XFactor m_Tensity;

      /// <summary>
      ///  
      /// </summary>
      public int m_Radius;
      
      /// <summary>
		///   
		/// </summary>
		private XAttractors m_Uplink;
		
      /// <summary>
      ///       -
      /// </summary>
      /// <param name="a_Uplink"></param>
      public XAttractor(XAttractors a_Uplink)
		{
			m_UIN = XGeneratorUIN.Generate();
			m_Uplink = a_Uplink;
         m_Tensity=XFactor.GetIdentity();
         m_Radius = 40;
         System.Random rand = new System.Random((int) m_UIN);
			m_Location = new XVector();
			m_Location.x = rand.Next(m_Uplink.m_Uplink.m_Width);
			m_Location.y = rand.Next(m_Uplink.m_Uplink.m_Height);
			m_OldLocation = new XVector();
		}

		

      /// <summary>
      ///     -   
      /// </summary>
      /// <param name="a_Uplink"></param>
      /// <param name="x"></param>
      /// <param name="y"></param>
      public XAttractor(XAttractors a_Uplink,int x,int y)
      {
			m_UIN = XGeneratorUIN.Generate();
         m_Uplink = a_Uplink;
         m_Radius = 40;
         m_Tensity=XFactor.GetIdentity();
         m_Location=new XVector(x,y);
         m_OldLocation = new XVector();
      }

		public XAttractor(XAttractors a_Uplink,int x,int y, XFactor a_Tensity):this(a_Uplink,x,y)
		{
			m_Tensity = a_Tensity;
		}
		private double GetScreenScale()
		{
			return m_Uplink.Uplink.m_ScreenScale;
		}
      
      /// <summary>
      ///  
      /// </summary>
      /// <param name="a_Target"></param>
      public void Draw(Graphics a_Target)
      {
			int x,y,width,height;
			x=m_Uplink.Uplink.WorldToScrX(m_Location.x-(int)(m_Radius/GetScreenScale()));
			y=m_Uplink.Uplink.WorldToScrY(m_Location.y-(int)(m_Radius/GetScreenScale()));
			width=(int)(2*m_Radius/GetScreenScale());
			height=(int)(2*m_Radius/GetScreenScale());
			a_Target.FillEllipse(Brushes.LightBlue ,x,y,width,height);
			m_OldLocation.x=m_Location.x;
			m_OldLocation.y=m_Location.y;
			//zBrush.Dispose();
      }

		/// <summary>
		///      
		/// </summary>
		/// <param name="a_Target"></param>
		public void RIPDraw(Graphics a_Target)
		{
			SolidBrush zBrush = new SolidBrush(m_Uplink.m_Uplink.m_BgColor);
			int x,y,width,height;
			x=m_Uplink.Uplink.WorldToScrX(Location.x - (int)(m_Radius/GetScreenScale()));
			y=m_Uplink.Uplink.WorldToScrY(Location.y - (int)(m_Radius/GetScreenScale()));
			width=(int)(2*m_Radius/GetScreenScale());
			height=(int)(2*m_Radius/GetScreenScale());
			a_Target.FillEllipse(zBrush,x,y,width,height);
			zBrush.Dispose();
		}

		/// <summary>
		/// 
		/// </summary>
		/// <param name="a_Target"></param>
		public void RIPOldDraw(Graphics a_Target)
		{
			SolidBrush zBrush = new SolidBrush(m_Uplink.m_Uplink.m_BgColor);
			int x,y,width,height;
			x=m_Uplink.Uplink.WorldToScrX(OldLocation.x - (int)(m_Radius/GetScreenScale()));
			y=m_Uplink.Uplink.WorldToScrY(OldLocation.y - (int)(m_Radius/GetScreenScale()));
			width=(int)(2*m_Radius/GetScreenScale());
			height=(int)(2*m_Radius/GetScreenScale());
			a_Target.FillEllipse(zBrush,x,y,width,height);
			zBrush.Dispose();
		}

	}

}
