using System;

namespace AQUARIUM
{
	/// <summary>
	/// v.1.0 (#3)
	/// N-  --      .
	///
	///  n- .    3 ,  
	///      -.
	///         
	/// .    Random'    
	///      .
	/// </summary>
   public class XFactor 
   {
      //	 
      private static int N = 3;
	  public static int Size
	  {
		  get
		  {
		  	return N;
		  }
	  }

      public double[] m_Factor = new double[N];

      /// <summary>
      ///  i-  
      /// </summary>
      public double this[int i]
      {
         get
         {
            return m_Factor[i];
         }
         set
         {
            m_Factor[i] = value;
         }
      }
		
		
      public XFactor()
      {
         for (int i=0; i < N; i++)
         {
            m_Factor[i] = 1;
         }
      }


      /// <summary>
      ///   
      /// </summary>
      /// <returns> </returns>
      public static XFactor GetIdentity()
      {
         XFactor zNew = new XFactor();
         for (int i=0; i<N; i++)
         {
            zNew[i]=1;
         }

         return zNew;
      }

      /// <summary>
      ///   
      /// </summary>
      /// <returns> </returns>
      public static XFactor GetNull()
      {
         XFactor zNew = new XFactor();
         for (int i=0; i<N; i++)
         {
            zNew[i]=0;
         }

         return zNew;
      }

      /// <summary>
      ///   
      /// </summary>
      /// <returns> </returns>
      public static XFactor GetRandom()
      {
         XFactor zNew = new XFactor();
			Random rand = new System.Random();
         for (int i=0; i<N; i++)
         {
            zNew[i]= rand.Next(100) / 100f;
         }

         return zNew;
      }

      /// <summary>
      ///  
      /// </summary>
      /// <param name="a_Factor"></param>
      public XFactor(XFactor a_Factor)
      {
         for(int i = 0; i < N; i++)
            m_Factor[i] = a_Factor[i];
      }
		
      /// <summary>
      ///  
      /// </summary>
      /// <param name="a_Factor1"> A</param>
      /// <param name="a_Factor2"> B</param>
      /// <returns>(A,B)</returns>
      public static double operator *(XFactor a_Factor1, XFactor a_Factor2)
      {
         double m_Result = 0;
         for(int i = 0; i < N; i++)
         {
            m_Result = m_Result + a_Factor1[i] * a_Factor2[i];
         }

         return m_Result;
      }
      
      /// <summary>
      ///    
      /// </summary>
      /// <param name="v"></param>
      /// <param name="d"></param>
      /// <returns>n- </returns>
      public static XFactor operator *(XFactor v,double d)
      {
         XFactor vv = new XFactor();
         for (int i=0 ; i<XFactor.N ; i++)
         {
            vv.m_Factor[i]=v.m_Factor[i]*d;
         }
         return vv;
      }

      /// <summary>
      ///  n- 
      /// </summary>
      /// <param name="a_Factor1"></param>
      /// <param name="a_Factor2"></param>
      /// <returns>n- </returns>
      public static XFactor operator +(XFactor a_Factor1, XFactor a_Factor2)
      {
         XFactor vv = new XFactor();
         for(int i = 0; i < N; i++)
         {
            vv.m_Factor[i]  = a_Factor1.m_Factor[i] + a_Factor2.m_Factor[i];
         }
         return vv;
      }
   }
}
