using System;

namespace AQUARIUM
{
	/// <summary>
	///  v.1.0 (#1)
	///   ))
	/// </summary>

   public class XMemory
	{

      /// <summary>
      ///   ""
      /// </summary>
      private double[] m_Memory;

      /// <summary>
      /// 
      /// </summary>
	   private XVector[] m_State;
		
	   /// <summary>
	   /// 
	   /// </summary>
	   private XVector[] m_Place;

	   /// <summary>
	   ///  
	   /// </summary>
	   private XFactor[] m_OldPrefs;


      /// <summary>
      ///  
      /// </summary>
      private int m_MemSize;


      /// <summary>
      ///      
      /// </summary>
      private int m_MemRef;

      /// <summary>
      ///        1
      /// </summary>
      /// <param name="i"></param>
      /// <returns>   </returns>
      private int Inc(int i)
      {
         if (i<m_MemSize-1)
         {
            i++;
         }
         else
         {
            i=0;
         }
         return i;
      }

      /// <summary>
      ///        1
      /// </summary>
      /// <param name="i"></param>
      /// <returns>  </returns>

      private int Dec(int i)
      {
         if (i>0)
         {
            i--;
         }
         else
         {
            i=m_MemSize-1;
         }
         return i;
      }

      /// <summary>
      ///     
      /// </summary>
      /// <param name="a_MemSize"></param>
		public XMemory(int a_MemSize)
		{
			m_MemSize=a_MemSize;
			m_Memory=new double[m_MemSize];
			m_State=new XVector[m_MemSize];
			m_Place=new XVector[m_MemSize];
			m_OldPrefs = new XFactor[m_MemSize];
			for(int i = 0; i < m_MemSize; i++)
			{
				m_State[i] = new XVector();
				m_Place[i] = new XVector();
				m_OldPrefs[i] = new XFactor();
			}
         m_MemRef=0;
		}

      /// <summary>
      ///     
      /// </summary>
      /// <param name="a_record"></param>
      public void Add(double a_record, XVector v, XVector a_Place, XFactor a_OldPrefs)
      {
		m_MemRef = Inc(m_MemRef);
		m_Memory[m_MemRef]=a_record;
		m_State[m_MemRef]=v;
		m_Place[m_MemRef]=a_Place;     
		m_OldPrefs[m_MemRef] = a_OldPrefs;
	  }

      /// <summary>
      ///   
      /// </summary>
      /// <returns> </returns>
      public int GetMemSize()
      {
         return m_MemSize;
      }

      /// <summary>
      ///       
      /// </summary>
      /// <param name="a_depth"></param>
      /// <returns></returns>
      private int RecordNum(int a_depth)
      {
         if ((a_depth<0)||(a_depth>=m_MemSize))
         {
            return -1;
         } 
         else
         {
            int refr;
            refr=m_MemRef;
            for (int i =a_depth; i>0; i--)
            {
               refr = Dec(refr);
            }
            return (refr);
         }
      }

      /// <summary>
      ///     ( 0 -  , 1 - ... )
      /// ""
      /// </summary>
      /// <param name="a_RemembrenceNum"></param>
      /// <returns></returns>
      public double Read(int a_RemembrenceNum)
      {
         if (a_RemembrenceNum>=m_MemSize)
         {
            a_RemembrenceNum=a_RemembrenceNum%m_MemSize;
         }
         int i = RecordNum(a_RemembrenceNum);
         return m_Memory[i];
      }

      /// <summary>
      ///      i- 
      /// </summary>
      /// <param name="a_RemembrenceNum"></param>
      /// <returns></returns>
      public XVector ReadState(int a_RemembrenceNum)
      {
         if (a_RemembrenceNum>=m_MemSize)
         {
            a_RemembrenceNum=a_RemembrenceNum%m_MemSize;
         }
         int i = RecordNum(a_RemembrenceNum);
         return m_State[i];
      }

	   /// <summary>
	   ///      i- 
	   /// </summary>
	   /// <param name="a_RemembrenceNum"></param>
	   /// <returns></returns>
	   public XFactor ReadPrefs(int a_RemembrenceNum)
	   {
		   if (a_RemembrenceNum>=m_MemSize)
		   {
			   a_RemembrenceNum=a_RemembrenceNum%m_MemSize;
		   }
		   int i = RecordNum(a_RemembrenceNum);
		   return m_OldPrefs[i];
	   }


		/// <summary>
		///    i- 
		/// </summary>
		/// <param name="a_RemembrenceNum"> </param>
		/// <returns> </returns>
		public XVector ReadPlace(int a_RemembrenceNum)
		{
			if (a_RemembrenceNum>=m_MemSize)
			{
				a_RemembrenceNum=a_RemembrenceNum%m_MemSize;
			}
			int i = RecordNum(a_RemembrenceNum);
			return m_Place[i];
		}

   }
}
