using System;

namespace AQUARIUM
{
	/// <summary>
	/// v.1.0 (#3)
	///   (  )
	///   +  *.
	/// </summary>
	public class XVector 
	{
		public int x, y;

		public XVector()
		{
			x = 0;
			y = 0;
		}

		public XVector(int a_x, int a_y)
		{	
			x = a_x;
			y = a_y;
		}

		public XVector(XVector v)
		{
			x = v.x;
			y = v.y;
		}

		public static XVector operator +(XVector a_V1, XVector a_V2)
		{
			XVector newVector = new XVector(a_V1.x + a_V2.x, a_V1.y + a_V2.y);
			return newVector;
		}

		public static XVector operator *(XVector a_V1, int a_coefficient)
		{
			XVector newVector = new XVector(a_V1.x * a_coefficient, a_V1.y * a_coefficient);
			return newVector;
		}

		public static XVector operator *(int a_coefficient, XVector a_V1)
		{
			XVector newVector = new XVector(a_V1.x * a_coefficient, a_V1.y * a_coefficient);
			return newVector;
		}

      public static XVector GetRandom(int a_WidthBorder, int a_HeightBorder)
      {
         Random rand = new Random();
         XVector v = new XVector();
         v.x=rand.Next(a_WidthBorder);
         v.y=rand.Next(a_HeightBorder);
         return v;
      }

		public static bool IsEqual(XVector a_V1, XVector a_V2)
		{
			if ((a_V1.x == a_V2.x) && (a_V1.y == a_V2.y)) return true;
			else return false; 
		}

      //   2- 
      public static double Distance(XVector a_v1, XVector a_v2)
      {
         double dist=Math.Sqrt((a_v1.x - a_v2.x) * (a_v1.x - a_v2.x) + (a_v1.y - a_v2.y) * (a_v1.y - a_v2.y));
         return dist;
      }

      public static double Mod(XVector a_v1)
      { 
         return Distance(a_v1, new XVector(0, 0));
      }
	}
}