using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.IO;
using System.Reflection;

namespace AQUARIUM
{
	/// <summary>
	/// Summary description for Form1.
	/// </summary>
	public class Form1 : System.Windows.Forms.Form
	{
		#region value initialization
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Panel pnPanel;
		private System.Windows.Forms.Timer Timer;
		private System.Windows.Forms.Button playbtn;
		private System.Windows.Forms.Button QuickAgentAddBtn;
		private int m_ComboIndex = 0;

		private XVector m_PlaceToPut;
		private XVector m_ExploreStart;
		private XVector m_LeftTopWhenExploreStarted;

		private XAddAgentForm AddAgentForm;

		/// <summary>
		///   
		/// </summary>
		private int m_Draggen;

		private System.Windows.Forms.Button DeleteAgentBtn;
		private System.Windows.Forms.Button QuickAttractorAddBtn;
		private System.Windows.Forms.Button DeleteAttractorBtn;
		private System.Windows.Forms.Button ClearWorldBtn;
		private System.Windows.Forms.CheckBox Save_CheckBox;
		private System.Windows.Forms.HScrollBar hWorldScrollBar;
		private System.Windows.Forms.VScrollBar vWorldScrollBar;
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.TrackBar ScaleTrackBar;
		private System.Windows.Forms.GroupBox ScaleGroupBox;
		private System.Windows.Forms.Label ScaleLabel;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TrackBar TimeLineTrackBar;
		private System.Windows.Forms.GroupBox JumpGroupBox;
		private System.Windows.Forms.Button JumpButton;
		private System.Windows.Forms.TextBox JumpTextBox;
		private System.Windows.Forms.ProgressBar JumpProgressBar;
		private System.Windows.Forms.CheckBox DrawJumpCheckBox;
		private System.Windows.Forms.ComboBox AddAgentComboBox;
		private System.Windows.Forms.Button ResetTransformButton;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.MenuItem FileMenuItem;
		private System.Windows.Forms.MenuItem QuitMenuItem;
		private System.Windows.Forms.MenuItem ShowGridMenuItem;
		private System.Windows.Forms.StatusBar StatusBar;
		private System.Windows.Forms.MainMenu MainMenu;
		private System.Windows.Forms.OpenFileDialog LoadAgentsDialog;
		private System.Windows.Forms.SaveFileDialog SaveAgentsDialog;
		private System.Windows.Forms.OpenFileDialog LoadAttractorsDialog;
		private System.Windows.Forms.SaveFileDialog SaveAttractorsDialog;
		private System.Windows.Forms.GroupBox TimeLineGroupBox;
		private System.Windows.Forms.MenuItem menuItem6;
		private System.Windows.Forms.MenuItem menuItem7;
		private System.Windows.Forms.MenuItem SaveAgentsMenuItem;
		private System.Windows.Forms.MenuItem SaveAttractorsMenuItem;
		private System.Windows.Forms.MenuItem LoadAgentsMenuItem;
		private System.Windows.Forms.MenuItem LoadAttractorsMenuItem;
		private System.Windows.Forms.MenuItem QuickSaveMenuItem;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem QuickLoadMenuItem;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem8;
		private System.Windows.Forms.MenuItem AddMultipleAgentsMenuItem;
		private System.Windows.Forms.MenuItem AddMultipleAttractorsMenuItem;
		private System.Windows.Forms.MenuItem LoadAssemblyMenuItem;
		private System.Windows.Forms.MenuItem menuItem5;
      
		/// <summary>
		///   :
		/// 0:    
		/// 1:  
		/// 2:     
		/// 10:  
		/// 20:  
		/// 30:  
		/// 40:  
		/// 50:      Drag'a
		/// </summary>
		private int m_State;

		public int State
		{
			get 
			{
				return m_State;
			}
			set
			{
				if ( ((value >= 1)&(value <=9))|((value >=20)&(value<=29)) )
				{
					AddAgentForm.Show(); 
				}
				else
				{
					if (AddAgentForm.Visible == true)
					{
						AddAgentForm.Visible = false;
					}
				}
				m_State = value;
			}
		}
      
		/// <summary>
		/// 
		/// </summary>
		public XEngine g_Engine;

		#endregion

		public Form1()
		{
			InitializeComponent();
			g_Engine = new XEngine(pnPanel.CreateGraphics(), pnPanel.Width, pnPanel.Height);
			g_Engine.m_BgColor = pnPanel.BackColor;	
			ShowGridMenuItem.Checked=true;
			g_Engine.ShowGrid=ShowGridMenuItem.Checked;
			m_ExploreStart = new XVector();
			m_LeftTopWhenExploreStarted = new XVector();
			this.JumpTextBox.Text="";
			JumpTextBox.BackColor=Color.Yellow;
			JumpButton.Enabled=false;
			JumpProgressBar.Visible=false;
			AddAgentForm = new XAddAgentForm(QuickAgentAddBtn.Left + QuickAgentAddBtn.Width + Left,QuickAgentAddBtn.Top + Top);
			ComboContent();
		}

		private void ComboContent()
		{
			AddAgentComboBox.Items.Clear();
			for (int i=0; i<g_Engine.m_AgentTypes.Count; i++)
			{
				AddAgentComboBox.Items.Add( (String) (g_Engine.m_AgentTypes[i]) );
			}
			if ( AddAgentComboBox.Items.Count>0 ) AddAgentComboBox.SelectedIndex = 0;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(Form1));
			this.pnPanel = new System.Windows.Forms.Panel();
			this.Timer = new System.Windows.Forms.Timer(this.components);
			this.playbtn = new System.Windows.Forms.Button();
			this.QuickAgentAddBtn = new System.Windows.Forms.Button();
			this.DeleteAgentBtn = new System.Windows.Forms.Button();
			this.QuickAttractorAddBtn = new System.Windows.Forms.Button();
			this.DeleteAttractorBtn = new System.Windows.Forms.Button();
			this.StatusBar = new System.Windows.Forms.StatusBar();
			this.ClearWorldBtn = new System.Windows.Forms.Button();
			this.Save_CheckBox = new System.Windows.Forms.CheckBox();
			this.hWorldScrollBar = new System.Windows.Forms.HScrollBar();
			this.vWorldScrollBar = new System.Windows.Forms.VScrollBar();
			this.ScaleTrackBar = new System.Windows.Forms.TrackBar();
			this.ScaleGroupBox = new System.Windows.Forms.GroupBox();
			this.ScaleLabel = new System.Windows.Forms.Label();
			this.TimeLineGroupBox = new System.Windows.Forms.GroupBox();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.TimeLineTrackBar = new System.Windows.Forms.TrackBar();
			this.JumpGroupBox = new System.Windows.Forms.GroupBox();
			this.JumpButton = new System.Windows.Forms.Button();
			this.JumpTextBox = new System.Windows.Forms.TextBox();
			this.DrawJumpCheckBox = new System.Windows.Forms.CheckBox();
			this.JumpProgressBar = new System.Windows.Forms.ProgressBar();
			this.AddAgentComboBox = new System.Windows.Forms.ComboBox();
			this.ResetTransformButton = new System.Windows.Forms.Button();
			this.MainMenu = new System.Windows.Forms.MainMenu();
			this.FileMenuItem = new System.Windows.Forms.MenuItem();
			this.SaveAgentsMenuItem = new System.Windows.Forms.MenuItem();
			this.SaveAttractorsMenuItem = new System.Windows.Forms.MenuItem();
			this.menuItem7 = new System.Windows.Forms.MenuItem();
			this.LoadAgentsMenuItem = new System.Windows.Forms.MenuItem();
			this.LoadAttractorsMenuItem = new System.Windows.Forms.MenuItem();
			this.menuItem5 = new System.Windows.Forms.MenuItem();
			this.LoadAssemblyMenuItem = new System.Windows.Forms.MenuItem();
			this.menuItem6 = new System.Windows.Forms.MenuItem();
			this.QuickSaveMenuItem = new System.Windows.Forms.MenuItem();
			this.QuickLoadMenuItem = new System.Windows.Forms.MenuItem();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.QuitMenuItem = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.ShowGridMenuItem = new System.Windows.Forms.MenuItem();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.AddMultipleAgentsMenuItem = new System.Windows.Forms.MenuItem();
			this.AddMultipleAttractorsMenuItem = new System.Windows.Forms.MenuItem();
			this.menuItem8 = new System.Windows.Forms.MenuItem();
			this.LoadAgentsDialog = new System.Windows.Forms.OpenFileDialog();
			this.SaveAgentsDialog = new System.Windows.Forms.SaveFileDialog();
			this.LoadAttractorsDialog = new System.Windows.Forms.OpenFileDialog();
			this.SaveAttractorsDialog = new System.Windows.Forms.SaveFileDialog();
			this.label1 = new System.Windows.Forms.Label();
			((System.ComponentModel.ISupportInitialize)(this.ScaleTrackBar)).BeginInit();
			this.ScaleGroupBox.SuspendLayout();
			this.TimeLineGroupBox.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.TimeLineTrackBar)).BeginInit();
			this.JumpGroupBox.SuspendLayout();
			this.SuspendLayout();
			// 
			// pnPanel
			// 
			this.pnPanel.BackColor = System.Drawing.SystemColors.Info;
			this.pnPanel.Location = new System.Drawing.Point(120, 8);
			this.pnPanel.Name = "pnPanel";
			this.pnPanel.Size = new System.Drawing.Size(600, 424);
			this.pnPanel.TabIndex = 1;
			this.pnPanel.MouseUp += new System.Windows.Forms.MouseEventHandler(this.pnPanel_MouseUp);
			this.pnPanel.Paint += new System.Windows.Forms.PaintEventHandler(this.pnPanel_Paint);
			this.pnPanel.MouseMove += new System.Windows.Forms.MouseEventHandler(this.pnPanel_MouseMove);
			this.pnPanel.MouseDown += new System.Windows.Forms.MouseEventHandler(this.pnPanel_MouseDown);
			// 
			// Timer
			// 
			this.Timer.Enabled = true;
			this.Timer.Tick += new System.EventHandler(this.Timer_Tick);
			// 
			// playbtn
			// 
			this.playbtn.AccessibleRole = System.Windows.Forms.AccessibleRole.None;
			this.playbtn.Image = ((System.Drawing.Image)(resources.GetObject("playbtn.Image")));
			this.playbtn.Location = new System.Drawing.Point(16, 120);
			this.playbtn.Name = "playbtn";
			this.playbtn.Size = new System.Drawing.Size(32, 32);
			this.playbtn.TabIndex = 1;
			this.playbtn.Click += new System.EventHandler(this.PlayButton_Click);
			// 
			// QuickAgentAddBtn
			// 
			this.QuickAgentAddBtn.Location = new System.Drawing.Point(8, 144);
			this.QuickAgentAddBtn.Name = "QuickAgentAddBtn";
			this.QuickAgentAddBtn.Size = new System.Drawing.Size(104, 32);
			this.QuickAgentAddBtn.TabIndex = 4;
			this.QuickAgentAddBtn.Text = "&Add Agent";
			this.QuickAgentAddBtn.Click += new System.EventHandler(this.QuickAgentAddBtn_Click);
			// 
			// DeleteAgentBtn
			// 
			this.DeleteAgentBtn.Location = new System.Drawing.Point(8, 184);
			this.DeleteAgentBtn.Name = "DeleteAgentBtn";
			this.DeleteAgentBtn.Size = new System.Drawing.Size(104, 32);
			this.DeleteAgentBtn.TabIndex = 5;
			this.DeleteAgentBtn.Text = "&Delete Agent";
			this.DeleteAgentBtn.Click += new System.EventHandler(this.QuickAgentDelete_Click);
			// 
			// QuickAttractorAddBtn
			// 
			this.QuickAttractorAddBtn.Location = new System.Drawing.Point(8, 224);
			this.QuickAttractorAddBtn.Name = "QuickAttractorAddBtn";
			this.QuickAttractorAddBtn.Size = new System.Drawing.Size(104, 32);
			this.QuickAttractorAddBtn.TabIndex = 6;
			this.QuickAttractorAddBtn.Text = "Add A&ttractor";
			this.QuickAttractorAddBtn.Click += new System.EventHandler(this.QuickAttractorAddBtn_Click);
			// 
			// DeleteAttractorBtn
			// 
			this.DeleteAttractorBtn.Location = new System.Drawing.Point(8, 264);
			this.DeleteAttractorBtn.Name = "DeleteAttractorBtn";
			this.DeleteAttractorBtn.Size = new System.Drawing.Size(104, 32);
			this.DeleteAttractorBtn.TabIndex = 7;
			this.DeleteAttractorBtn.Text = "Delete Attra&ctor";
			this.DeleteAttractorBtn.Click += new System.EventHandler(this.QuickDeleteAttractorBtn_Click);
			// 
			// StatusBar
			// 
			this.StatusBar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.StatusBar.Dock = System.Windows.Forms.DockStyle.None;
			this.StatusBar.Location = new System.Drawing.Point(0, 555);
			this.StatusBar.Name = "StatusBar";
			this.StatusBar.Size = new System.Drawing.Size(824, 22);
			this.StatusBar.TabIndex = 0;
			// 
			// ClearWorldBtn
			// 
			this.ClearWorldBtn.Location = new System.Drawing.Point(8, 16);
			this.ClearWorldBtn.Name = "ClearWorldBtn";
			this.ClearWorldBtn.Size = new System.Drawing.Size(104, 32);
			this.ClearWorldBtn.TabIndex = 1;
			this.ClearWorldBtn.Text = "&Clear";
			this.ClearWorldBtn.Click += new System.EventHandler(this.ClearWorldBtn_Click);
			// 
			// Save_CheckBox
			// 
			this.Save_CheckBox.Location = new System.Drawing.Point(8, 496);
			this.Save_CheckBox.Name = "Save_CheckBox";
			this.Save_CheckBox.TabIndex = 8;
			this.Save_CheckBox.Text = "Save to log  file";
			// 
			// hWorldScrollBar
			// 
			this.hWorldScrollBar.Cursor = System.Windows.Forms.Cursors.Default;
			this.hWorldScrollBar.Location = new System.Drawing.Point(120, 432);
			this.hWorldScrollBar.Name = "hWorldScrollBar";
			this.hWorldScrollBar.Size = new System.Drawing.Size(600, 16);
			this.hWorldScrollBar.TabIndex = 0;
			this.hWorldScrollBar.ValueChanged += new System.EventHandler(this.hWorldScrollBar_ValueChanged);
			this.hWorldScrollBar.Scroll += new System.Windows.Forms.ScrollEventHandler(this.hWorldScrollBar_Scroll);
			// 
			// vWorldScrollBar
			// 
			this.vWorldScrollBar.Location = new System.Drawing.Point(720, 8);
			this.vWorldScrollBar.Name = "vWorldScrollBar";
			this.vWorldScrollBar.Size = new System.Drawing.Size(16, 424);
			this.vWorldScrollBar.TabIndex = 0;
			this.vWorldScrollBar.ValueChanged += new System.EventHandler(this.vWorldScrollBar_ValueChanged);
			// 
			// ScaleTrackBar
			// 
			this.ScaleTrackBar.Location = new System.Drawing.Point(8, 16);
			this.ScaleTrackBar.Maximum = 20;
			this.ScaleTrackBar.Minimum = 1;
			this.ScaleTrackBar.Name = "ScaleTrackBar";
			this.ScaleTrackBar.Orientation = System.Windows.Forms.Orientation.Vertical;
			this.ScaleTrackBar.Size = new System.Drawing.Size(45, 104);
			this.ScaleTrackBar.TabIndex = 0;
			this.ScaleTrackBar.Value = 2;
			this.ScaleTrackBar.ValueChanged += new System.EventHandler(this.ScaleTrackBar_ValueChanged);
			// 
			// ScaleGroupBox
			// 
			this.ScaleGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.ScaleGroupBox.Controls.Add(this.ScaleLabel);
			this.ScaleGroupBox.Controls.Add(this.ScaleTrackBar);
			this.ScaleGroupBox.Location = new System.Drawing.Point(744, 8);
			this.ScaleGroupBox.Name = "ScaleGroupBox";
			this.ScaleGroupBox.Size = new System.Drawing.Size(72, 144);
			this.ScaleGroupBox.TabIndex = 15;
			this.ScaleGroupBox.TabStop = false;
			this.ScaleGroupBox.Text = "Scale";
			// 
			// ScaleLabel
			// 
			this.ScaleLabel.Location = new System.Drawing.Point(8, 120);
			this.ScaleLabel.Name = "ScaleLabel";
			this.ScaleLabel.Size = new System.Drawing.Size(40, 16);
			this.ScaleLabel.TabIndex = 1;
			this.ScaleLabel.Text = "10%";
			this.ScaleLabel.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// TimeLineGroupBox
			// 
			this.TimeLineGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.TimeLineGroupBox.Controls.Add(this.label2);
			this.TimeLineGroupBox.Controls.Add(this.label3);
			this.TimeLineGroupBox.Controls.Add(this.TimeLineTrackBar);
			this.TimeLineGroupBox.Controls.Add(this.playbtn);
			this.TimeLineGroupBox.Location = new System.Drawing.Point(744, 152);
			this.TimeLineGroupBox.Name = "TimeLineGroupBox";
			this.TimeLineGroupBox.Size = new System.Drawing.Size(72, 160);
			this.TimeLineGroupBox.TabIndex = 16;
			this.TimeLineGroupBox.TabStop = false;
			this.TimeLineGroupBox.Text = "TimeLine";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(40, 21);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(16, 11);
			this.label2.TabIndex = 0;
			this.label2.Text = "hi";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(40, 100);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(24, 12);
			this.label3.TabIndex = 0;
			this.label3.Text = "low";
			// 
			// TimeLineTrackBar
			// 
			this.TimeLineTrackBar.Location = new System.Drawing.Point(8, 16);
			this.TimeLineTrackBar.Maximum = 5;
			this.TimeLineTrackBar.Minimum = 1;
			this.TimeLineTrackBar.Name = "TimeLineTrackBar";
			this.TimeLineTrackBar.Orientation = System.Windows.Forms.Orientation.Vertical;
			this.TimeLineTrackBar.Size = new System.Drawing.Size(45, 104);
			this.TimeLineTrackBar.TabIndex = 0;
			this.TimeLineTrackBar.Value = 3;
			this.TimeLineTrackBar.ValueChanged += new System.EventHandler(this.TimeLineTrackBar_ValueChanged);
			// 
			// JumpGroupBox
			// 
			this.JumpGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.JumpGroupBox.Controls.Add(this.JumpButton);
			this.JumpGroupBox.Controls.Add(this.JumpTextBox);
			this.JumpGroupBox.Controls.Add(this.DrawJumpCheckBox);
			this.JumpGroupBox.Location = new System.Drawing.Point(744, 320);
			this.JumpGroupBox.Name = "JumpGroupBox";
			this.JumpGroupBox.Size = new System.Drawing.Size(72, 104);
			this.JumpGroupBox.TabIndex = 17;
			this.JumpGroupBox.TabStop = false;
			this.JumpGroupBox.Text = "Jump";
			// 
			// JumpButton
			// 
			this.JumpButton.Enabled = false;
			this.JumpButton.Location = new System.Drawing.Point(8, 48);
			this.JumpButton.Name = "JumpButton";
			this.JumpButton.Size = new System.Drawing.Size(56, 24);
			this.JumpButton.TabIndex = 1;
			this.JumpButton.Text = "Jump!";
			this.JumpButton.Click += new System.EventHandler(this.JumpButton_Click);
			// 
			// JumpTextBox
			// 
			this.JumpTextBox.Location = new System.Drawing.Point(8, 24);
			this.JumpTextBox.MaxLength = 5;
			this.JumpTextBox.Name = "JumpTextBox";
			this.JumpTextBox.Size = new System.Drawing.Size(56, 20);
			this.JumpTextBox.TabIndex = 0;
			this.JumpTextBox.Text = "";
			this.JumpTextBox.TextChanged += new System.EventHandler(this.JumpTextBox_TextChanged);
			// 
			// DrawJumpCheckBox
			// 
			this.DrawJumpCheckBox.Location = new System.Drawing.Point(8, 72);
			this.DrawJumpCheckBox.Name = "DrawJumpCheckBox";
			this.DrawJumpCheckBox.Size = new System.Drawing.Size(56, 24);
			this.DrawJumpCheckBox.TabIndex = 2;
			this.DrawJumpCheckBox.Text = "Draw";
			// 
			// JumpProgressBar
			// 
			this.JumpProgressBar.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.JumpProgressBar.Location = new System.Drawing.Point(120, 515);
			this.JumpProgressBar.Name = "JumpProgressBar";
			this.JumpProgressBar.Size = new System.Drawing.Size(624, 24);
			this.JumpProgressBar.TabIndex = 0;
			this.JumpProgressBar.Visible = false;
			// 
			// AddAgentComboBox
			// 
			this.AddAgentComboBox.DisplayMember = "ty";
			this.AddAgentComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.AddAgentComboBox.Location = new System.Drawing.Point(8, 120);
			this.AddAgentComboBox.Name = "AddAgentComboBox";
			this.AddAgentComboBox.Size = new System.Drawing.Size(104, 21);
			this.AddAgentComboBox.TabIndex = 3;
			this.AddAgentComboBox.ValueMember = "Valya";
			this.AddAgentComboBox.SelectedIndexChanged += new System.EventHandler(this.AddAgentComboBox_SelectedIndexChanged);
			// 
			// ResetTransformButton
			// 
			this.ResetTransformButton.Location = new System.Drawing.Point(8, 56);
			this.ResetTransformButton.Name = "ResetTransformButton";
			this.ResetTransformButton.Size = new System.Drawing.Size(104, 32);
			this.ResetTransformButton.TabIndex = 2;
			this.ResetTransformButton.Text = "Reset Transform";
			this.ResetTransformButton.Click += new System.EventHandler(this.ResetTransformButton_Click);
			// 
			// MainMenu
			// 
			this.MainMenu.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					 this.FileMenuItem,
																					 this.menuItem3,
																					 this.menuItem2});
			// 
			// FileMenuItem
			// 
			this.FileMenuItem.Index = 0;
			this.FileMenuItem.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																						 this.SaveAgentsMenuItem,
																						 this.SaveAttractorsMenuItem,
																						 this.menuItem7,
																						 this.LoadAgentsMenuItem,
																						 this.LoadAttractorsMenuItem,
																						 this.menuItem5,
																						 this.LoadAssemblyMenuItem,
																						 this.menuItem6,
																						 this.QuickSaveMenuItem,
																						 this.QuickLoadMenuItem,
																						 this.menuItem1,
																						 this.QuitMenuItem});
			this.FileMenuItem.Text = "&File";
			// 
			// SaveAgentsMenuItem
			// 
			this.SaveAgentsMenuItem.Index = 0;
			this.SaveAgentsMenuItem.Text = "Save Agents";
			this.SaveAgentsMenuItem.Click += new System.EventHandler(this.menuItem1_Click_1);
			// 
			// SaveAttractorsMenuItem
			// 
			this.SaveAttractorsMenuItem.Index = 1;
			this.SaveAttractorsMenuItem.Text = "Save Attractors";
			this.SaveAttractorsMenuItem.Click += new System.EventHandler(this.menuItem2_Click);
			// 
			// menuItem7
			// 
			this.menuItem7.Index = 2;
			this.menuItem7.Text = "-";
			// 
			// LoadAgentsMenuItem
			// 
			this.LoadAgentsMenuItem.Index = 3;
			this.LoadAgentsMenuItem.Text = "Load Agents";
			this.LoadAgentsMenuItem.Click += new System.EventHandler(this.menuItem4_Click);
			// 
			// LoadAttractorsMenuItem
			// 
			this.LoadAttractorsMenuItem.Index = 4;
			this.LoadAttractorsMenuItem.Text = "Load Attractors";
			this.LoadAttractorsMenuItem.Click += new System.EventHandler(this.menuItem5_Click);
			// 
			// menuItem5
			// 
			this.menuItem5.Index = 5;
			this.menuItem5.Text = "-";
			// 
			// LoadAssemblyMenuItem
			// 
			this.LoadAssemblyMenuItem.Index = 6;
			this.LoadAssemblyMenuItem.Text = "Load Assembly...";
			this.LoadAssemblyMenuItem.Click += new System.EventHandler(this.LoadAssemblyMenuItem_Click);
			// 
			// menuItem6
			// 
			this.menuItem6.Index = 7;
			this.menuItem6.Text = "-";
			// 
			// QuickSaveMenuItem
			// 
			this.QuickSaveMenuItem.Index = 8;
			this.QuickSaveMenuItem.Text = "Quick Save";
			this.QuickSaveMenuItem.Click += new System.EventHandler(this.menuItem8_Click);
			// 
			// QuickLoadMenuItem
			// 
			this.QuickLoadMenuItem.Index = 9;
			this.QuickLoadMenuItem.Text = "Quick Load";
			this.QuickLoadMenuItem.Click += new System.EventHandler(this.QuickLoadMenuItem_Click);
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 10;
			this.menuItem1.Text = "-";
			// 
			// QuitMenuItem
			// 
			this.QuitMenuItem.Index = 11;
			this.QuitMenuItem.Text = "&Quit";
			this.QuitMenuItem.Click += new System.EventHandler(this.QuitMenuItem_Click);
			// 
			// menuItem3
			// 
			this.menuItem3.Index = 1;
			this.menuItem3.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.ShowGridMenuItem});
			this.menuItem3.Text = "&View";
			// 
			// ShowGridMenuItem
			// 
			this.ShowGridMenuItem.Index = 0;
			this.ShowGridMenuItem.Text = "Show &Grid";
			this.ShowGridMenuItem.Click += new System.EventHandler(this.ShowGridMenuItem_Click);
			// 
			// menuItem2
			// 
			this.menuItem2.Index = 2;
			this.menuItem2.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.AddMultipleAgentsMenuItem,
																					  this.AddMultipleAttractorsMenuItem,
																					  this.menuItem8});
			this.menuItem2.Text = "Service";
			// 
			// AddMultipleAgentsMenuItem
			// 
			this.AddMultipleAgentsMenuItem.Index = 0;
			this.AddMultipleAgentsMenuItem.Text = "Add Multiple Agents";
			this.AddMultipleAgentsMenuItem.Click += new System.EventHandler(this.AddMultipleAgentsMenuItem_Click);
			// 
			// AddMultipleAttractorsMenuItem
			// 
			this.AddMultipleAttractorsMenuItem.Index = 1;
			this.AddMultipleAttractorsMenuItem.Text = "Add Multiple Attractors";
			this.AddMultipleAttractorsMenuItem.Click += new System.EventHandler(this.AddMultipleAttractorsMenuItem_Click);
			// 
			// menuItem8
			// 
			this.menuItem8.Index = 2;
			this.menuItem8.Text = "-";
			// 
			// LoadAgentsDialog
			// 
			this.LoadAgentsDialog.Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*";
			this.LoadAgentsDialog.RestoreDirectory = true;
			this.LoadAgentsDialog.FileOk += new System.ComponentModel.CancelEventHandler(this.LoadAgentsDialog_FileOk);
			// 
			// SaveAgentsDialog
			// 
			this.SaveAgentsDialog.Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*";
			this.SaveAgentsDialog.FileOk += new System.ComponentModel.CancelEventHandler(this.SaveAgentsDialog_FileOk);
			// 
			// LoadAttractorsDialog
			// 
			this.LoadAttractorsDialog.Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*";
			this.LoadAttractorsDialog.FileOk += new System.ComponentModel.CancelEventHandler(this.LoadAttractorsDialog_FileOk);
			// 
			// SaveAttractorsDialog
			// 
			this.SaveAttractorsDialog.Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*";
			this.SaveAttractorsDialog.FileOk += new System.ComponentModel.CancelEventHandler(this.SaveAttractorsDialog_FileOk);
			// 
			// label1
			// 
			this.label1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.label1.Font = new System.Drawing.Font("Microsoft Sans Serif", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(204)));
			this.label1.Location = new System.Drawing.Point(408, 491);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(296, 32);
			this.label1.TabIndex = 0;
			this.label1.Text = "label1";
			this.label1.Visible = false;
			// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.AutoScroll = true;
			this.ClientSize = new System.Drawing.Size(824, 577);
			this.Controls.Add(this.ResetTransformButton);
			this.Controls.Add(this.AddAgentComboBox);
			this.Controls.Add(this.ScaleGroupBox);
			this.Controls.Add(this.JumpGroupBox);
			this.Controls.Add(this.TimeLineGroupBox);
			this.Controls.Add(this.vWorldScrollBar);
			this.Controls.Add(this.Save_CheckBox);
			this.Controls.Add(this.ClearWorldBtn);
			this.Controls.Add(this.StatusBar);
			this.Controls.Add(this.DeleteAttractorBtn);
			this.Controls.Add(this.DeleteAgentBtn);
			this.Controls.Add(this.QuickAgentAddBtn);
			this.Controls.Add(this.pnPanel);
			this.Controls.Add(this.QuickAttractorAddBtn);
			this.Controls.Add(this.hWorldScrollBar);
			this.Controls.Add(this.JumpProgressBar);
			this.Controls.Add(this.label1);
			this.Menu = this.MainMenu;
			this.Name = "Form1";
			this.Text = "Aquarium v2.21";
			this.SizeChanged += new System.EventHandler(this.Form1_SizeChanged);
			this.Load += new System.EventHandler(this.Form1_Load);
			((System.ComponentModel.ISupportInitialize)(this.ScaleTrackBar)).EndInit();
			this.ScaleGroupBox.ResumeLayout(false);
			this.TimeLineGroupBox.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.TimeLineTrackBar)).EndInit();
			this.JumpGroupBox.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]


		static void Main() 
		{
			Application.Run(new Form1());
		}

		private void Form1_Load(object sender, System.EventArgs e)
		{
			State = 0;
			m_PlaceToPut = new XVector();
		}

		private void Timer_Tick(object sender, System.EventArgs e)
		{
			g_Engine.NextTurn();
			g_Engine.Draw();
			if (Save_CheckBox.Checked) g_Engine.LogFileSave();
		}

		private void PlayButton_Click(object sender, System.EventArgs e)
		{
			Timer.Enabled=!Timer.Enabled;
			if (Timer.Enabled) 
			{
				//playbtn.Image=Image.FromFile("play.bmp");
				StatusBar.Text="";
			}
			else 
			{
				//playbtn.Image=Image.FromFile("pause.bmp");
				StatusBar.Text="Paused...";
			}  
		}

		private void QuickAgentAddBtn_Click(object sender, System.EventArgs e)
		{
			if ((State>0)&(State<10))
			{
				State=0;
				StatusBar.Text="";
			} 
			else
			{
				State=1;
				StatusBar.Text="Click to set Agent's Location";
			}
		}

		
		private void pnPanel_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
				if (e.Button == MouseButtons.Left)
				{
					switch (State)
					{
						case 1:
						{
							State = 2;
							StatusBar.Text="Click to set Agent's Speed";
							m_PlaceToPut.x=g_Engine.ScrToWorldX(e.X);
							m_PlaceToPut.y=g_Engine.ScrToWorldY(e.Y);
							break;
						}
						case 2:
						{
							Type type; 
							object s = AddAgentComboBox.SelectedItem;
							type = (Type) s;
							XVector speed = new XVector(g_Engine.ScrToWorldX(e.X)-m_PlaceToPut.x,g_Engine.ScrToWorldY(e.Y)-m_PlaceToPut.y);
							XFactor zFactor = new XFactor();
							for (int i=0; i<AddAgentForm.m_Dimensity; i++)
							{
								zFactor[i] = AddAgentForm.m_PrefEdits[i].Correct? AddAgentForm.m_PrefEdits[i].Value:1;
							}
							if (type != null)
							{
								ConstructorInfo ctor = type.GetConstructor(new Type[] {typeof(XAgents), typeof(int), typeof(int), typeof(int), typeof(int)});
								XAgent agent = (XAgent) ctor.Invoke(new object[] {this.g_Engine.m_Agents, m_PlaceToPut.x, m_PlaceToPut.y, speed.x, speed.y});
								g_Engine.m_Agents.Add(agent);
							}
							State = 1;
							StatusBar.Text="Click to set Agent's Location";
							break;
						}
						case 10:
						{
							int n = g_Engine.m_Agents.SearchByLocation(new XVector( g_Engine.ScrToWorldX(e.X),g_Engine.ScrToWorldY(e.Y)));
							if (n!=-1)
							{
								g_Engine.m_Agents.GetAgent(n).RIPDraw(g_Engine.m_Canvas);
								g_Engine.m_Agents.Remove(n);
							}
							break;
						}
						case 20:
						{
							XFactor zFactor = new XFactor();
							for (int i=0; i<AddAgentForm.m_Dimensity; i++)
							{
								zFactor[i] = AddAgentForm.m_PrefEdits[i].Correct? AddAgentForm.m_PrefEdits[i].Value : 1;
							}
							XAttractor zAttractor = new XAttractor(g_Engine.m_Attractors,g_Engine.ScrToWorldX(e.X),g_Engine.ScrToWorldY(e.Y),zFactor);
							g_Engine.m_Attractors.Add(zAttractor);
							break;
						}
						case 30:
						{
							int n=g_Engine.m_Attractors.SearchByLocation(new XVector(g_Engine.ScrToWorldX(e.X),g_Engine.ScrToWorldY(e.Y)));
							if (n!=-1)
							{
								g_Engine.m_Attractors.GetAttractor(n).RIPDraw(g_Engine.m_Canvas);
								g_Engine.m_Attractors.Remove(n); 
							} 
							break;
						}
						case 40:
						{
							State=0;
							StatusBar.Text="";
							break;
						}
						case 50:
						{
							State=0;
							StatusBar.Text="";
							break;
						}
					}
				}
				else 
				{
					if (e.Button == MouseButtons.Right)
					{
						State=0;
					}
				}
		}

		private void QuickAgentDelete_Click(object sender, System.EventArgs e)
		{
			int k=State%10;
			if ((State>=10)&(State<20))
			{
				State=0;
				StatusBar.Text="";
			} 
			else
			{
				State=10;
				StatusBar.Text="Choose Agent to delete";
			}
		}

		private void QuickAttractorAddBtn_Click(object sender, System.EventArgs e)
		{
			if ((State>=20)&(State<30))
			{
				State = 0;
				StatusBar.Text="";
			}
			else
			{
				State = 20;
				StatusBar.Text="Click to set Attractor's Location";
			}
		}

		private void QuickDeleteAttractorBtn_Click(object sender, System.EventArgs e)
		{
			if ((State>=30)&(State<40))
			{
				State = 0;
				StatusBar.Text="";
			}
			else
			{
				State = 30;
				StatusBar.Text="Choose Attractor to Delete";
			}
		}

		private void pnPanel_MouseMove(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if ( (State==40)&(e.Button==MouseButtons.Left) )
			{
				g_Engine.m_Attractors.GetAttractor(m_Draggen).SetState(new XVector(g_Engine.ScrToWorldX(e.X),g_Engine.ScrToWorldY(e.Y)));
			}
			else
			{
				if ( (State==50)&(e.Button==MouseButtons.Left) )
				{
					int x=m_LeftTopWhenExploreStarted.x+g_Engine.ScrToWorldX(m_ExploreStart.x)-g_Engine.ScrToWorldX(e.X);
					int y=m_LeftTopWhenExploreStarted.y+g_Engine.ScrToWorldY(m_ExploreStart.y)-g_Engine.ScrToWorldY(e.Y);
					XVector vect = g_Engine.CorrectLeftTop(x,y);

					if (x!=vect.x) 
					{
						m_ExploreStart.x=e.X; 
						m_LeftTopWhenExploreStarted.x=g_Engine.m_LeftTop.x;
					}
					
					if (y!=vect.y)
					{
						m_ExploreStart.y=e.Y;
						m_LeftTopWhenExploreStarted.y=g_Engine.m_LeftTop.y;
					}
					

					if ((g_Engine.m_LeftTop.x!=vect.x)|(g_Engine.m_LeftTop.y!=vect.y))
					{																					 
						g_Engine.RIPDraw();
						g_Engine.m_LeftTop.x=vect.x;
						g_Engine.m_LeftTop.y=vect.y;
						CorrectWorldScrollBars();
						g_Engine.Draw();
					}

				}
			}

				label1.Text=g_Engine.ScrToWorldX(e.X).ToString() +"*"+ g_Engine.ScrToWorldY(e.Y).ToString() +"       "+ e.X.ToString()+"*"+e.Y.ToString()+"   "+g_Engine.m_LeftTop.x.ToString()+"*"+g_Engine.m_LeftTop.y.ToString();
		}
		private void pnPanel_MouseDown(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button==MouseButtons.Right)
			{
				State=0;
				StatusBar.Text="";
			} 
			else
			{
				if ((e.Button==MouseButtons.Left)&(State==0))
				{
					int n = g_Engine.m_Attractors.SearchByLocation(new XVector(g_Engine.ScrToWorldX(e.X),g_Engine.ScrToWorldY(e.Y)));
					if (n != -1)
					{
						State=40;
						m_Draggen=n;
					} 
					else
					{
						m_ExploreStart.x=e.X;
						m_ExploreStart.y=e.Y;
						m_LeftTopWhenExploreStarted.x=g_Engine.m_LeftTop.x;
						m_LeftTopWhenExploreStarted.y=g_Engine.m_LeftTop.y;
						State=50;
					}
				}
			}
		}

		private void ClearWorldBtn_Click(object sender, System.EventArgs e)
		{
			g_Engine.Clear();
		}

		#region Bars
		private void hWorldScrollBar_ValueChanged(object sender, System.EventArgs e)
		{
			g_Engine.RIPDraw();
			//ToDo:   !!
			g_Engine.m_LeftTop.x=(int) ((g_Engine.m_Width-g_Engine.m_VisibleWidth)*(hWorldScrollBar.Value)/(hWorldScrollBar.Maximum-9));
		}

		private void vWorldScrollBar_ValueChanged(object sender, System.EventArgs e)
		{
			g_Engine.RIPDraw();
			//ToDo:   !!
			g_Engine.m_LeftTop.y=(int) ((g_Engine.m_Height-g_Engine.m_VisibleHeight)*(vWorldScrollBar.Value)/(vWorldScrollBar.Maximum-9));
		}

		private void ScaleTrackBar_ValueChanged(object sender, System.EventArgs e)
		{
			g_Engine.RIPDraw();
			XVector vect = new XVector(g_Engine.m_LeftTop);
			vect.x+=(g_Engine.m_VisibleWidth/2);
			vect.y+=(g_Engine.m_VisibleHeight/2);

			g_Engine.m_Canvas.ResetTransform();
			double newWorldScale=(this.ScaleTrackBar.Value*0.05);
			g_Engine.m_WorldScale=(float) newWorldScale;
			g_Engine.m_ScreenScale=g_Engine.CalculateScreenScale(pnPanel.Width,pnPanel.Height);
			g_Engine.m_VisibleWidth = (int) (pnPanel.Width/g_Engine.m_ScreenScale);
			g_Engine.m_VisibleHeight = (int) (pnPanel.Height/g_Engine.m_ScreenScale);
			g_Engine.m_Canvas.ScaleTransform((float)g_Engine.m_ScreenScale,(float) g_Engine.m_ScreenScale);
			g_Engine.CenterBy(vect);
			CorrectWorldScrollBars();
			
			this.ScaleLabel.Text=((int)(g_Engine.m_WorldScale*100)).ToString()+"%";
		}

		private void TimeLineTrackBar_ValueChanged(object sender, System.EventArgs e)
		{
			switch (this.TimeLineTrackBar.Value)
			{
				case 1:
					this.Timer.Interval=1000;
					break;
				case 2:
					this.Timer.Interval=250;
					break;
				case 3:
					this.Timer.Interval=100;
					break;
				case 4:
					this.Timer.Interval=30;
					break;
				case 5:
					this.Timer.Interval=2;
					break;
				default:
					this.Timer.Interval=100;
					break;
			}
		}
		#endregion
		#region Jump
		private void JumpTextBox_TextChanged(object sender, System.EventArgs e)
		{
			bool stop=false;
			int i=0;
			while ((!stop)&(i<JumpTextBox.Text.Length))
			{
				if (!((this.JumpTextBox.Text[i]<='9')&(this.JumpTextBox.Text[i]>=0))) stop=true;
				i++;
			};
			if (JumpTextBox.Text.Length==0) stop=true;
			if (stop)
			{
				JumpTextBox.BackColor=Color.Yellow;
				JumpButton.Enabled=false;
			}
			else
			{
				JumpTextBox.BackColor=Color.White;
				JumpButton.Enabled=true;
			}
		}
		
		private void JumpButton_Click(object sender, System.EventArgs e)
		{
			Timer.Enabled=false;
			int n=0;
			for (int i=0; i<JumpTextBox.Text.Length;i++)
			{
				n=n*10+JumpTextBox.Text[i]-'0';
			}
			JumpProgressBar.Visible=true;
			JumpProgressBar.Value=0;
			g_Engine.RIPDraw();
			for (int i=0; i<n; i++)
			{
				g_Engine.NextTurn();
				if (DrawJumpCheckBox.Checked) g_Engine.Draw(); 
				JumpProgressBar.Value=(int)(100*i/n);
				if (Save_CheckBox.Checked) g_Engine.LogFileSave();
			}
			g_Engine.Draw();
			JumpProgressBar.Visible=false;
			Timer.Enabled=true;
		}
		#endregion
		private void ResetTransformButton_Click(object sender, System.EventArgs e)
		{
			g_Engine.RIPDraw();
			g_Engine.ResetTransform(pnPanel.Width,pnPanel.Height);
			g_Engine.Draw();
		}

		private void QuitMenuItem_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void ShowGridMenuItem_Click(object sender, System.EventArgs e)
		{
			ShowGridMenuItem.Checked=!ShowGridMenuItem.Checked;
			g_Engine.ShowGrid=ShowGridMenuItem.Checked;
		}

		private void Form1_SizeChanged(object sender, System.EventArgs e)
		{
			if (( (Width-233)/g_Engine.m_ScreenScale<=g_Engine.m_Width )&( (Height-165) /g_Engine.m_ScreenScale<=g_Engine.m_Height))
			{
				pnPanel.Width=Width-233;
				pnPanel.Height=Height-165;

				g_Engine.m_Canvas = pnPanel.CreateGraphics();
				g_Engine.m_Canvas.ScaleTransform((float)g_Engine.m_ScreenScale,(float)g_Engine.m_ScreenScale);
				vWorldScrollBar.Left=pnPanel.Left + pnPanel.Width;
				hWorldScrollBar.Top=pnPanel.Top + pnPanel.Height;
				vWorldScrollBar.Height=pnPanel.Height;
				hWorldScrollBar.Width=pnPanel.Width;
				g_Engine.m_VisibleWidth=(int)(pnPanel.Width/g_Engine.m_ScreenScale);
				g_Engine.m_VisibleHeight=(int)(pnPanel.Height/g_Engine.m_ScreenScale);
				g_Engine.m_WorldScale=(float)(g_Engine.CalculateWorldScale(pnPanel.Width,pnPanel.Height));
				CorrectWorldScrollBars();
				try
				{
					this.ScaleTrackBar.Value=(int)(g_Engine.m_WorldScale*20);
				}
				catch (Exception exception){}
			}
			else 
			{
			}
		}

		private void AddAgentComboBox_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			State=1;
			StatusBar.Text="Click to set Agent's Location";
			m_ComboIndex = AddAgentComboBox.SelectedIndex;
		}

		private void CorrectWorldScrollBars()
		{
			if ((g_Engine.m_LeftTop.x!=0)&&(g_Engine.m_Width!=g_Engine.m_VisibleWidth))hWorldScrollBar.Value =(int)((g_Engine.m_LeftTop.x*(hWorldScrollBar.Maximum-9))/(g_Engine.m_Width-g_Engine.m_VisibleWidth));else hWorldScrollBar.Value=0;
			if ((g_Engine.m_LeftTop.y!=0)&&(g_Engine.m_Height!=g_Engine.m_VisibleWidth)) vWorldScrollBar.Value = (int)((g_Engine.m_LeftTop.y*(vWorldScrollBar.Maximum-9))/(g_Engine.m_Height-g_Engine.m_VisibleHeight)); else vWorldScrollBar.Value=0;
		}

		private void menuItem1_Click_1(object sender, System.EventArgs e)
		{
			SaveAgentsDialog.ShowDialog();		
		}

		private void menuItem2_Click(object sender, System.EventArgs e)
		{
			SaveAttractorsDialog.ShowDialog();		
		}

		private void menuItem4_Click(object sender, System.EventArgs e)
		{
			LoadAgentsDialog.ShowDialog();
		}

		private void menuItem5_Click(object sender, System.EventArgs e)
		{
			LoadAttractorsDialog.ShowDialog();		
		}

		private void menuItem8_Click(object sender, System.EventArgs e)
		{
			g_Engine.m_Agents.SaveInXML("Agents.xml");
			g_Engine.m_Attractors.SaveInXML("Attractors.xml");
		}

		private void QuickLoadMenuItem_Click(object sender, System.EventArgs e)
		{
			g_Engine.m_Agents.LoadFromXML("Agents.xml");
			g_Engine.m_Attractors.LoadFromXML("Attractors.xml");
		}

		private void SaveAgentsDialog_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			g_Engine.m_Agents.SaveInXML(SaveAgentsDialog.FileName.ToString());
		}

		private void SaveAttractorsDialog_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			g_Engine.m_Attractors.SaveInXML(SaveAttractorsDialog.FileName.ToString());
		}

		private void LoadAttractorsDialog_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			g_Engine.m_Attractors.LoadFromXML(LoadAttractorsDialog.FileName.ToString());
		}	
	
		private void LoadAgentsDialog_FileOk(object sender, System.ComponentModel.CancelEventArgs e)
		{
			g_Engine.m_Agents.LoadFromXML(LoadAgentsDialog.FileName.ToString());
		}


		private void AddMultipleAgentsMenuItem_Click(object sender, System.EventArgs e)
		{
			XAddMultipleAgentsForm AddMultipleAgentsForm = new XAddMultipleAgentsForm(g_Engine.m_Width,g_Engine.m_Height,g_Engine.m_Agents, g_Engine.m_AgentTypes);
		}

		private void AddMultipleAttractorsMenuItem_Click(object sender, System.EventArgs e)
		{
			XAddMultipleAttractorsForm AddMulipleAttractorsForm = new XAddMultipleAttractorsForm(g_Engine.m_Width,g_Engine.m_Height,g_Engine.m_Attractors, g_Engine.m_AttractorTypes);
		}

		
		private void LoadAssemblyMenuItem_Click(object sender, System.EventArgs e)
		{
			OpenFileDialog dlg = new OpenFileDialog();
			dlg.InitialDirectory = Application.StartupPath;
			if (dlg.ShowDialog() == DialogResult.OK)
			{
				Assembly assembly = Assembly.LoadFile(dlg.FileName);
				Type[] types = assembly.GetTypes();
				int n = types.Length;
				for (int i = 0; i < n; i++)
				{
					Type type = types[i];
					if (type.IsSubclassOf(typeof(XAgent)))
					{
						AddAgentComboBox.Items.Add(type);
						g_Engine.m_AgentTypes.Add(type.ToString());
					}
				}
			}
		}

		private void hWorldScrollBar_Scroll(object sender, System.Windows.Forms.ScrollEventArgs e)
		{
		
		}

		private void pnPanel_Paint(object sender, System.Windows.Forms.PaintEventArgs e)
		{
		
		}
	}
}
