using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace AQUARIUM
{
	/// <summary>
	/// Summary description for AddAgentForm.
	/// </summary>
	public class XAddAgentForm : System.Windows.Forms.Form
	{

		public class XPrefTextBox: TextBox
		{
			public XPrefTextBox():base()
			{
				Width = 30;
				Top = 8;
				MaxLength = 4;
				TextIsCorrect();
			}

			private bool IsCorrect;
			public bool Correct
			{
				get
				{
					return IsCorrect;
				}
			}

			private double TValue;
			public double Value
			{
				get
				{
					if (Correct) return TValue; else return -1;
				}
			}

			public bool TextIsCorrect()
			{
				Regex DotRegex = new Regex("^0.[0-9]{1,2}$");
				Regex DotLessRegex = new Regex("^[0-1]{1}$");
				Regex OneAndDotRegex = new Regex("^1.0$");
				bool stop = !(DotRegex.IsMatch(Text) | DotLessRegex.IsMatch(Text) | OneAndDotRegex.IsMatch(Text));
				IsCorrect = !stop;
				if (IsCorrect) TValue = Convert.ToDouble(Text);
				return stop;
			}

		}

		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		public XPrefTextBox[] m_PrefEdits;
		private Button m_RandomButton;
		private Button m_NullButton;
		public XFactor m_Factor;
		public int m_Dimensity;
		
		public XAddAgentForm(int x, int y)
		{
			InitializeComponent();
			m_Dimensity=3;
			int m_ButtonWidth = 40;
			int m_EditWidth = 30;
			int m_ElementHeight = 20;
			int m_ElementTop = 8;
			m_PrefEdits = new XPrefTextBox[m_Dimensity];
			int delta = 10;
			for (int i=0; i<m_Dimensity; i++)
			{
				m_PrefEdits[i] = new XPrefTextBox();
				m_PrefEdits[i].SuspendLayout();
				m_PrefEdits[i].Left = delta + i*(m_EditWidth+delta);
				m_PrefEdits[i].Top = m_ElementTop;
				m_PrefEdits[i].TextChanged += new System.EventHandler(this.m_PrefEdits_TextChanged);
				m_PrefEdits_TextChanged(m_PrefEdits[i],new System.EventArgs());
				Controls.Add(m_PrefEdits[i]);
			}

			m_RandomButton = new Button();
			m_RandomButton.Left = (m_EditWidth+delta)*m_Dimensity + delta;
			m_RandomButton.Top = m_ElementTop;
			m_RandomButton.Width = m_ButtonWidth;
			m_RandomButton.Height = m_ElementHeight;
			m_RandomButton.Text = "Rand";

			m_NullButton = new Button();
			m_NullButton.Left = (m_EditWidth+delta)*m_Dimensity + 2*delta + m_RandomButton.Width;
			m_NullButton.Top = m_ElementTop;
			m_NullButton.Width = m_ButtonWidth;
			m_NullButton.Height = m_ElementHeight;
			m_NullButton.Text = "Null";

			Width = m_NullButton.Left + m_NullButton.Width + delta;
			Height = 2*m_RandomButton.Top + m_RandomButton.Height+10;
			Left = x+400;
			Top = y+300;
			Controls.Add(m_RandomButton);
			Controls.Add(m_NullButton);
			m_RandomButton.Click += new System.EventHandler(m_RandomButton_Click);
			m_NullButton.Click += new System.EventHandler(m_NullButton_Click);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			// 
			// XAddAgentForm
			// 
			this.AccessibleRole = System.Windows.Forms.AccessibleRole.Client;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 62);
			this.ControlBox = false;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "XAddAgentForm";
			this.Opacity = 0.65;
			this.ShowInTaskbar = false;
			this.TopMost = true;
			this.Load += new System.EventHandler(this.AddAgentForm_Load);
			this.VisibleChanged += new System.EventHandler(this.AddAgentForm_VisibleChanged);

		}
		#endregion

		private void AddAgentForm_Load(object sender, System.EventArgs e)
		{
		
		}

		private void AddAgentForm_VisibleChanged(object sender, System.EventArgs e)
		{	
		}

		private void m_RandomButton_Click(object sender, System.EventArgs e)
		{
			m_Factor = XFactor.GetRandom();
			for (int i=0; i<3; i++)
			{
				m_PrefEdits[i].Text = m_Factor[i].ToString();
			}
		}

		private void m_PrefEdits_TextChanged(object sender, System.EventArgs e)
		{
			if ((sender as XPrefTextBox).TextIsCorrect())
			{
				(sender  as XPrefTextBox).BackColor=Color.Yellow;
			}
			else
			{
				(sender  as XPrefTextBox).BackColor=Color.White;
			}
		}

		private void m_NullButton_Click(object sender, System.EventArgs e)
		{
			for (int i=0; i<m_Dimensity; i++)
			{
				this.m_PrefEdits[i].Text = "0";
			}
		}
	}
}
