using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Text.RegularExpressions;

namespace AQUARIUM
{
	/// <summary>
	/// Summary description for AddMultiple.
	/// </summary>
	public abstract class XAddMultipleForm : System.Windows.Forms.Form
	{
		protected long m_WorldWidth;
		protected long m_WorldHeight;
		protected int m_Quantity;
		protected String m_Type;
		protected bool m_InputIsCorrect;

		protected System.Windows.Forms.TextBox QuantityTextBox;
		protected System.Windows.Forms.TextBox DensityTextBox;
		protected System.Windows.Forms.Button AddButton;
		protected System.Windows.Forms.RadioButton QuantityRadioButton;
		protected System.Windows.Forms.RadioButton DensityRadioButton;
		protected System.Windows.Forms.Label label1;
		protected System.Windows.Forms.ComboBox MultipleAddComboBox;
		private System.Windows.Forms.Button CancelButton;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		protected System.ComponentModel.Container components = null;

		public XAddMultipleForm(int a_WorldWidth,int a_WorldHeight,XTypeList a_Types)
		{
			InitializeComponent();
			QuantityTextBox.SuspendLayout();
			DensityTextBox.SuspendLayout();
			m_WorldWidth=a_WorldWidth;
			m_WorldHeight=a_WorldHeight;
			QuantityTextBox.BackColor = Color.Yellow;
			QuantityTextBox_TextChanged(null, new System.EventArgs());
			AddButton.Enabled = false;
			for (int i=0; i<a_Types.Count; i++)
			{
				MultipleAddComboBox.Items.Add( (String) (a_Types[i]) );
			}
			if ( MultipleAddComboBox.Items.Count>0 ) MultipleAddComboBox.SelectedIndex = 0;
			m_InputIsCorrect = false;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.QuantityTextBox = new System.Windows.Forms.TextBox();
			this.DensityTextBox = new System.Windows.Forms.TextBox();
			this.AddButton = new System.Windows.Forms.Button();
			this.QuantityRadioButton = new System.Windows.Forms.RadioButton();
			this.DensityRadioButton = new System.Windows.Forms.RadioButton();
			this.label1 = new System.Windows.Forms.Label();
			this.MultipleAddComboBox = new System.Windows.Forms.ComboBox();
			this.CancelButton = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// QuantityTextBox
			// 
			this.QuantityTextBox.Location = new System.Drawing.Point(80, 40);
			this.QuantityTextBox.MaxLength = 5;
			this.QuantityTextBox.Name = "QuantityTextBox";
			this.QuantityTextBox.Size = new System.Drawing.Size(56, 20);
			this.QuantityTextBox.TabIndex = 0;
			this.QuantityTextBox.Text = "";
			this.QuantityTextBox.TextChanged += new System.EventHandler(this.QuantityTextBox_TextChanged);
			// 
			// DensityTextBox
			// 
			this.DensityTextBox.BackColor = System.Drawing.SystemColors.Control;
			this.DensityTextBox.Enabled = false;
			this.DensityTextBox.Location = new System.Drawing.Point(80, 72);
			this.DensityTextBox.MaxLength = 7;
			this.DensityTextBox.Name = "DensityTextBox";
			this.DensityTextBox.Size = new System.Drawing.Size(56, 20);
			this.DensityTextBox.TabIndex = 1;
			this.DensityTextBox.Text = "";
			this.DensityTextBox.TextChanged += new System.EventHandler(this.DensityTextBox_TextChanged);
			// 
			// AddButton
			// 
			this.AddButton.Location = new System.Drawing.Point(8, 104);
			this.AddButton.Name = "AddButton";
			this.AddButton.Size = new System.Drawing.Size(88, 32);
			this.AddButton.TabIndex = 2;
			this.AddButton.Text = "&Add";
			this.AddButton.Click += new System.EventHandler(this.AddButton_Click);
			// 
			// QuantityRadioButton
			// 
			this.QuantityRadioButton.Checked = true;
			this.QuantityRadioButton.Location = new System.Drawing.Point(8, 40);
			this.QuantityRadioButton.Name = "QuantityRadioButton";
			this.QuantityRadioButton.Size = new System.Drawing.Size(64, 24);
			this.QuantityRadioButton.TabIndex = 5;
			this.QuantityRadioButton.TabStop = true;
			this.QuantityRadioButton.Text = "Quantity";
			this.QuantityRadioButton.CheckedChanged += new System.EventHandler(this.QuantityRadioButton_CheckedChanged);
			// 
			// DensityRadioButton
			// 
			this.DensityRadioButton.Location = new System.Drawing.Point(8, 72);
			this.DensityRadioButton.Name = "DensityRadioButton";
			this.DensityRadioButton.Size = new System.Drawing.Size(64, 24);
			this.DensityRadioButton.TabIndex = 6;
			this.DensityRadioButton.Text = "Density";
			this.DensityRadioButton.CheckedChanged += new System.EventHandler(this.DensityRadioButton_CheckedChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(144, 72);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(56, 23);
			this.label1.TabIndex = 7;
			this.label1.Text = "1/(100^2)";
			// 
			// MultipleAddComboBox
			// 
			this.MultipleAddComboBox.DisplayMember = "ty";
			this.MultipleAddComboBox.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.MultipleAddComboBox.Location = new System.Drawing.Point(8, 8);
			this.MultipleAddComboBox.Name = "MultipleAddComboBox";
			this.MultipleAddComboBox.Size = new System.Drawing.Size(192, 21);
			this.MultipleAddComboBox.TabIndex = 8;
			this.MultipleAddComboBox.ValueMember = "Valya";
			this.MultipleAddComboBox.SelectedIndexChanged += new System.EventHandler(this.MultipleAddComboBox_SelectedIndexChanged);
			// 
			// CancelButton
			// 
			this.CancelButton.Location = new System.Drawing.Point(112, 104);
			this.CancelButton.Name = "CancelButton";
			this.CancelButton.Size = new System.Drawing.Size(88, 32);
			this.CancelButton.TabIndex = 9;
			this.CancelButton.Text = "&Cancel";
			this.CancelButton.Click += new System.EventHandler(this.CancelButton_Click);
			// 
			// XAddMultipleForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(210, 152);
			this.Controls.Add(this.CancelButton);
			this.Controls.Add(this.MultipleAddComboBox);
			this.Controls.Add(this.label1);
			this.Controls.Add(this.DensityRadioButton);
			this.Controls.Add(this.QuantityRadioButton);
			this.Controls.Add(this.AddButton);
			this.Controls.Add(this.DensityTextBox);
			this.Controls.Add(this.QuantityTextBox);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "XAddMultipleForm";
			this.Text = "AddMultiple";
			this.TopMost = true;
			this.Load += new System.EventHandler(this.AddMultiple_Load);
			this.ResumeLayout(false);

		}
		#endregion

		private void AddMultiple_Load(object sender, System.EventArgs e)
		{
		
		}

		private void QuantityRadioButton_CheckedChanged(object sender, System.EventArgs e)
		{
			QuantityTextBox.Enabled = QuantityRadioButton.Checked;
			if (QuantityRadioButton.Checked)
			{
				QuantityTextBox.Focus();
				QuantityTextBox_TextChanged(this, new System.EventArgs());
			} 
			else
			{
				QuantityTextBox.BackColor = System.Drawing.SystemColors.Control;
			}
			
		}

		private void DensityRadioButton_CheckedChanged(object sender, System.EventArgs e)
		{
			DensityTextBox.Enabled = DensityRadioButton.Checked;
			if (DensityRadioButton.Checked)
			{
				DensityTextBox.Focus();
				DensityTextBox_TextChanged(this, new System.EventArgs());
			}
			else
			{
				DensityTextBox.BackColor = System.Drawing.SystemColors.Control;
			}
			
		}

		private bool TextIsInteger(String a_String)
		{
			Regex Integer = new Regex("^[0-9]{1,}$");
			return Integer.IsMatch(a_String);
		}

		private bool TextIsDouble(String a_String)
		{
			Regex DoubleWithDot = new Regex("^[0]{1,}.[0-9]{1,}$");
			if (DoubleWithDot.IsMatch(a_String)) return true;
			Regex DoubleWithoutDot = new Regex("^0{1,}$");
			return (DoubleWithoutDot.IsMatch(a_String));
		}

		private double CalculateDensity(int a_Quantity)
		{
			double x = Convert.ToDouble(a_Quantity*100*100);
			double y = Convert.ToDouble (m_WorldWidth*m_WorldHeight);
			double d = x / y;
			return d;
		}

		private int CalculateQuantity(double a_Density)
		{
			double x = a_Density*m_WorldWidth*m_WorldHeight;
			double y = 100*100;
      	int i = (int) (x/y);
			if (i<100000) return i; else return 99999;
		}

		private void QuantityTextBox_TextChanged(object sender, System.EventArgs e)
		{
			if (QuantityTextBox.Enabled) 
			{
				if (TextIsInteger(QuantityTextBox.Text))
				{
					QuantityTextBox.BackColor = Color.White;
					m_Quantity = Convert.ToInt32(QuantityTextBox.Text);
					double d = CalculateDensity(Convert.ToInt32(QuantityTextBox.Text));
					if (d!=0) DensityTextBox.Text = Convert.ToString(Math.Round(d,4)); else DensityTextBox.Text = "0";
					AddButton.Enabled = true;
					m_InputIsCorrect = true;
				} 
				else
				{
					QuantityTextBox.BackColor = Color.Yellow;
					//DensityTextBox.Text = "";
					//m_Quantity = 0;
					AddButton.Enabled = false;
				}
			}
		}

		private void DensityTextBox_TextChanged(object sender, System.EventArgs e)
		{
			if (DensityTextBox.Enabled)
			{
				if (TextIsDouble(DensityTextBox.Text))
				{
					DensityTextBox.BackColor = Color.White;
					QuantityTextBox.Text = (CalculateQuantity(Convert.ToDouble(DensityTextBox.Text))).ToString();
					m_Quantity =  Convert.ToInt32(QuantityTextBox.Text);
					AddButton.Enabled = true;
					m_InputIsCorrect = true;
				}
				else
				{
					DensityTextBox.BackColor = Color.Yellow;
					//QuantityTextBox.Text = "";
					//m_Quantity = 0;
					AddButton.Enabled = false;
				}
			}
		}

		protected abstract void AddButton_Click(object sender, System.EventArgs e);

		private void MultipleAddComboBox_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			m_Type = MultipleAddComboBox.Text;
		}

		private void CancelButton_Click(object sender, System.EventArgs e)
		{
			Close();
		}
	}
}
